/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import net.sergecoude.TbiGeneral.*;

public class Application { 

  private String _nom = null;
  private String _cheminMainClasse = null;
  private File _repertoire = null;
  private PluginEvaluations _instance = null;
  private Vector<Eleve> _lesElevesSelectionnes = null;
  private Classe _laClasseSelectionnee = null;

  public Application(String nom, String cheminMainClasse, File rep) {
    _nom = nom;
    _cheminMainClasse = cheminMainClasse;
    _repertoire = rep;
  }
  
  public String getNom() {
    return _nom;
  }
  
  public void setNom(String nom) {
    _nom = nom;
  }
  
  public String getCheminMainClasse() {
    return _cheminMainClasse;
  }
  
  public File getRepertoire() {
    return _repertoire;
  }

  public void setInstance(PluginEvaluations instance) {
    _instance = instance;
  }
  
  public PluginEvaluations getInstance() {
    return _instance;
  }
  
  public String toString() {
    return _nom;
  }
  
  public int getNbEvaluations() {
    if (_instance != null)
      return _instance.getNbEvaluations();
    return 0;
  }

	public boolean generationPDFPossible() {
	  return (_instance != null && _instance.generationPDFPossible());
  }
  
  public void setClasseSelectionnee(Classe classe) {
    _laClasseSelectionnee = classe;
    if (_instance != null)
      _instance.setClasseSelectionnee(classe);
  }
  
  public void setElevesSelectionnes(Vector<Eleve> lesEleves) {
    _lesElevesSelectionnes = lesEleves;
    if (_instance != null)
      _instance.setElevesSelectionnes(lesEleves);
  }

}
