/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import java.io.*;
import java.util.*;
import com.itextpdf.text.*;
import com.itextpdf.text.pdf.*;

public class CustomPdfPage extends PdfPageEventHelper {
  
  private TbiAdmin _app = null;
  private BaseFont _helv = null;
//  private PdfTemplate _total = null;
  private String _titre = "";
  
  public CustomPdfPage(TbiAdmin app, String titre) {
    _app = app;
    _titre = titre;
  }

  @Override
  public void onOpenDocument(PdfWriter writer, Document document) {
//    _total = writer.getDirectContent().createTemplate(100, 100);
//    _total.setBoundingBox(new Rectangle(-20, -20, 100, 100));
    try {
        _helv = BaseFont.createFont(BaseFont.HELVETICA, BaseFont.WINANSI, BaseFont.NOT_EMBEDDED);
    } catch (DocumentException e) {
      _app.message(e, _app.MESSAGE_ERREUR);
    } catch (IOException e) {
      _app.message(e, _app.MESSAGE_ERREUR);
    }
  }
  
  @Override
  public void onStartPage(PdfWriter writer, Document document) {
    PdfContentByte directcontent = writer.getDirectContent();
    directcontent.saveState();
    directcontent.beginText();
    directcontent.setFontAndSize(_helv, 14);
    directcontent.showTextAligned(Element.ALIGN_CENTER, _titre, document.left()+document.right()/2, document.top()+10, 0f);
    directcontent.endText();
    directcontent.restoreState();
  } 
 
  @Override
  public void onEndPage(PdfWriter writer, Document document) {
    PdfContentByte directcontent = writer.getDirectContent();
    directcontent.saveState();
    ApplicationInfoAdmin appInfo = (ApplicationInfoAdmin)_app.getApplicationInfo();
    String texte = appInfo.getNom() + " " + appInfo.getVersion() + " http://caroline-et-serge.coude.net/     généré le ";
    Calendar ajd = Calendar.getInstance();
    texte += (ajd.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + ajd.get(Calendar.DAY_OF_MONTH) + "/";
    texte += (ajd.get(Calendar.MONTH) < 9 ? "0" : "") + (ajd.get(Calendar.MONTH)+1) + "/";
    texte += ajd.get(Calendar.YEAR) + " ";
    texte += (ajd.get(Calendar.HOUR_OF_DAY) < 10 ? "0" : "") + ajd.get(Calendar.HOUR_OF_DAY) + ":";
    texte += (ajd.get(Calendar.MINUTE) < 10 ? "0" : "") + ajd.get(Calendar.MINUTE) + ":";
    texte += (ajd.get(Calendar.SECOND) < 10 ? "0" : "") + ajd.get(Calendar.SECOND);
    directcontent.beginText();
    directcontent.setFontAndSize(_helv, 6);
    directcontent.showTextAligned(Element.ALIGN_LEFT, texte, document.right()+15, document.bottom()-15, 90f);
    directcontent.endText();
    directcontent.restoreState();
  } 
 
}   