/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.io.*;
import javax.swing.border.*;
import java.awt.image.*;
import java.awt.event.*;
import net.sergecoude.TbiGeneral.*;
 
public class ItemEleve extends ItemEleveGen implements ActionListener, ItemListener {
                          
  private final static long serialVersionUID = 1L;

  private TbiApp _app;                              
  private bouton _bEditer = null;
  private bouton _bSupprimer = null;
  private JLabel _itemNom;
  private JLabel _itemPrenom;
  private JLabel _itemNomUsuel;
  private JLabel _itemDateNaissance;
  private JLabel _itemNiveau;
  private JLabel _itemSexe;
  private JPanel _pPresent;
  private CheckBox _bPresent;
  private bouton _iPresentTrue;
  private bouton _iPresentFalse;
  private JList _jListe;
  private boolean _edition = false;

  static public int lPresent = 50;
  static public int hPresent = 35;  
  static public int lNom = 150;
  static public int hNom = 35;
  static public int lPrenom = 150;
  static public int hPrenom = 35;
  static public int lNomUsuel = 150;
  static public int hNomUsuel = 35;
  static public int lId = 150;
  static public int hId = 35;
  static public int lDateNaissance = 120;
  static public int hDateNaissance = 35;
  static public int lNiveau = 75;
  static public int hNiveau = 35;
  static public int lSexe = 70;
  static public int hSexe = 35;
  
  public ItemEleve(Eleve eleve) {
    super(0.7f, eleve);
    _app = _eleve.getApplication();
    setOpaque(false);
    setLayout(new FlowLayout(FlowLayout.LEFT));
    setBackground(Color.white);
    _pPresent = new JPanel(new CardLayout());
    _pPresent.setOpaque(false);
    _bPresent = new CheckBox();
    _bPresent.setPreferredSize(new Dimension(lPresent, hPresent));
    _bPresent.setOpaque(false);
    _bPresent.setSelected(_eleve.estPresent());
    _bPresent.addItemListener(this);
    _pPresent.add(_bPresent,"editionTrue");
    try {
      _iPresentTrue = new bouton(_app.getRessourceByConf("checkboxpresent"));
      JPanel pIPresent = new JPanel();
      pIPresent.setOpaque(false);
      pIPresent.add(_iPresentTrue);
      _pPresent.add(pIPresent, "editionFalsePresent");
      _iPresentFalse = new bouton(_app.getRessourceByConf("checkboxabsent"));
      JPanel pIAbsent = new JPanel();
      pIAbsent.setOpaque(false);
      pIAbsent.add(_iPresentFalse);
      _pPresent.add(pIAbsent, "editionFalseAbsent");
      } catch (Exception e) {
        _app.log(e);
      }
    _itemNom = new JLabel("");
    _itemNom.setFont(new Font("SansSerif", Font.BOLD, 20));
    _itemNom.setPreferredSize(new Dimension(lNom, hNom));
    _itemPrenom = new JLabel("");
    _itemPrenom.setFont(new Font("SansSerif", Font.BOLD, 20));
    _itemPrenom.setPreferredSize(new Dimension(lPrenom, hPrenom));
    _itemNomUsuel = new JLabel("");
    _itemNomUsuel.setFont(new Font("SansSerif", Font.BOLD, 20));
    _itemNomUsuel.setPreferredSize(new Dimension(lNom, hNom));
    _itemDateNaissance = new JLabel("");
    _itemDateNaissance.setFont(new Font("SansSerif", Font.BOLD, 18));
    _itemDateNaissance.setPreferredSize(new Dimension(lDateNaissance, hDateNaissance));
    _itemNiveau = new JLabel("");
    _itemNiveau.setFont(new Font("SansSerif", Font.BOLD, 18));
    _itemNiveau.setPreferredSize(new Dimension(lNiveau, hNiveau));
    _itemSexe = new JLabel("");
    _itemSexe.setFont(new Font("SansSerif", Font.BOLD, 18));
    _itemSexe.setPreferredSize(new Dimension(lSexe, hSexe));
    add(_pPresent);
    add(_itemNom);
    add(_itemPrenom);
    add(_itemNomUsuel);
    add(_itemSexe);
    add(_itemDateNaissance);
    add(_itemNiveau);
    if (_bEditer == null) 
      try {
        _bEditer = new bouton(_app.getRessourceByConf("boutoneditereleve"));
        add(_bEditer);
        _bEditer.addActionListener(this);      
      } catch (Exception e) {
        _app.log(e);
      }
    if (_bSupprimer == null) 
      try {  
        _bSupprimer = new bouton(_app.getRessourceByConf("boutonsupprimereleve"));
        add(_bSupprimer);
        _bSupprimer.addActionListener(this);
      } catch (Exception e) {
        _app.log(e);
      }
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    g.setColor(_estSelectionne ? _jListe.getSelectionBackground() : _jListe.getBackground());
    g.fillRect(0, 0, getWidth(), getHeight());
  }

  public void setNom(String nom) {
    _itemNom.setText(nom);
  }

  public void setPrenom(String prenom) {
    _itemPrenom.setText(prenom);
  }
    
  public void setNomUsuel(String nomUsuel) {
    _itemNomUsuel.setText(nomUsuel);
  }
  
  public void setDateNaissance(String date) {
    _itemDateNaissance.setText(date);
  }
  
  public void setSexe(String sexe) {
    _itemSexe.setText(sexe);
  }
  
  public void setNiveau(String niveau) {
    _itemNiveau.setText(niveau);
  }

  public void setPresent(boolean present) {
    _bPresent.setSelected(present);
  }
  
  public void setEdition(boolean edition) {
    _edition = edition;
    _bEditer.setVisible(_edition);
    _bSupprimer.setVisible(_edition);
    CardLayout cl = (CardLayout)(_pPresent.getLayout());
    if (_edition)
      cl.show(_pPresent, "editionTrue");
    else {
      if (_bPresent.isSelected())
        cl.show(_pPresent, "editionFalsePresent");
      else
        cl.show(_pPresent, "editionFalseAbsent");  
    }
  }
  
  public void setJList(JList l) {
    _jListe = l;
  }
      
	public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bEditer) {
		  ((TbiAdmin)_app).editerEleve(_eleve);
		}
		if (source == _bSupprimer) {
		  ((TbiAdmin)_app).supprimerEleve(_eleve);
		}
	}
	
  public void itemStateChanged(ItemEvent e) {
    Object source = e.getItemSelectable();
    if (source == _bPresent) {
      if (e.getStateChange() == ItemEvent.DESELECTED) {
        _eleve.setPresent(false);
        _bPresent.setSelected(false);  
      }
      if (e.getStateChange() == ItemEvent.SELECTED) {
        _eleve.setPresent(true);
        _bPresent.setSelected(true);  
      }
      if (_edition) // on notifie la modification que lorsque on édite l'élève
        ((TbiAdmin)_app).modification(_eleve.getClasse(), true);
    }
  }	

}