/*
Copyright Caroline et Serge COUDÉ, (03/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiAdmin;

import java.util.*; 
import net.sergecoude.TbiGeneral.*;
import net.sergecoude.TbiAdmin.*;

public class ItemEvaluation extends ItemObjet {

  private final static long serialVersionUID = 1L;
  
  protected Evaluation _evaluation = null;
  
  public ItemEvaluation(float transparence, Evaluation evaluation) {
    super(transparence);
    _evaluation = evaluation;
    _lIntitule.setText(genereLibelleItem());
  }

  public ItemEvaluation(Evaluation evaluation) {
    this(1f, evaluation);
  }
  
  public Evaluation getEvaluation() {
    return _evaluation;
  }
  
  private String genereLibelleItem() {
    String nom = "";
    if (_evaluation.getDateStart() != null) 
      if (_evaluation.getDateStop() != null) {
        Calendar dateStart = _evaluation.getDateStart();
        Calendar dateStop = _evaluation.getDateStop();
        if (dateStart.get(Calendar.YEAR) == dateStop.get(Calendar.YEAR) &&
            dateStart.get(Calendar.MONTH) == dateStop.get(Calendar.MONTH) &&
            dateStart.get(Calendar.DAY_OF_MONTH) == dateStop.get(Calendar.DAY_OF_MONTH)) {
          nom += TbiApp.getJourDeLaSemaine(dateStart) + " ";  
          nom += (dateStart.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + dateStart.get(Calendar.DAY_OF_MONTH) + "/";
          nom += (dateStart.get(Calendar.MONTH) < 9 ? "0" : "") + (dateStart.get(Calendar.MONTH)+1) + " ";
          nom += (dateStart.get(Calendar.HOUR_OF_DAY) < 10 ? "0" : "") + dateStart.get(Calendar.HOUR_OF_DAY) + ":";
          nom += (dateStart.get(Calendar.MINUTE) < 10 ? "0" : "") + dateStart.get(Calendar.MINUTE) + " - ";
          nom += (dateStop.get(Calendar.HOUR_OF_DAY) < 10 ? "0" : "") + dateStop.get(Calendar.HOUR_OF_DAY) + ":";
          nom += (dateStop.get(Calendar.MINUTE) < 10 ? "0" : "") + dateStop.get(Calendar.MINUTE);
        } else {
          nom += TbiApp.getJourDeLaSemaine(dateStart) + " ";
          nom += (dateStart.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + dateStart.get(Calendar.DAY_OF_MONTH) + "/";
          nom += (dateStart.get(Calendar.MONTH) < 9 ? "0" : "") + (dateStart.get(Calendar.MONTH)+1) + " ";
          nom += (dateStart.get(Calendar.HOUR_OF_DAY) < 10 ? "0" : "") + dateStart.get(Calendar.HOUR_OF_DAY) + ":";
          nom += (dateStart.get(Calendar.MINUTE) < 10 ? "0" : "") + dateStart.get(Calendar.MINUTE) + " - ";
          nom += TbiApp.getJourDeLaSemaine(dateStop) + " ";
          nom += (dateStop.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + dateStop.get(Calendar.DAY_OF_MONTH) + "/";
          nom += (dateStop.get(Calendar.MONTH) < 9 ? "0" : "") + (dateStop.get(Calendar.MONTH)+1) + " ";
          nom += (dateStop.get(Calendar.HOUR_OF_DAY) < 10 ? "0" : "") + dateStop.get(Calendar.HOUR_OF_DAY) + ":";
          nom += (dateStop.get(Calendar.MINUTE) < 10 ? "0" : "") + dateStop.get(Calendar.MINUTE);
        }
      } else {
          Calendar dateStart = _evaluation.getDateStart();
          nom += TbiApp.getJourDeLaSemaine(dateStart) + " ";
          nom += (dateStart.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + dateStart.get(Calendar.DAY_OF_MONTH) + "/";
          nom += (dateStart.get(Calendar.MONTH) < 9 ? "0" : "") + (dateStart.get(Calendar.MONTH)+1) + " ";
          nom += (dateStart.get(Calendar.HOUR_OF_DAY) < 10 ? "0" : "") + dateStart.get(Calendar.HOUR_OF_DAY) + ":";
          nom += (dateStart.get(Calendar.MINUTE) < 10 ? "0" : "") + dateStart.get(Calendar.MINUTE) + " - ";
      }
    return nom;
  } 
  
  public static Comparator<ItemEvaluation> getComparator(ArrayList<ParametreDeTri> paramTri) {
    return new ItemEvaluationComparator(paramTri);
  }
  
  private static class ItemEvaluationComparator implements Comparator<ItemEvaluation> {
    private ArrayList<ParametreDeTri> _parametres;

    private ItemEvaluationComparator(ArrayList<ParametreDeTri> parametres) {
      _parametres = parametres;
    }

    public int compare(ItemEvaluation i1, ItemEvaluation i2) {
      int comparaison = 0;
      Evaluation e1 = i1.getEvaluation();
      Evaluation e2 = i2.getEvaluation();
      for(int i = 0; i < _parametres.size(); i++ ) {
        int idparam = _parametres.get(i).getId();
        if (idparam == Evaluation.DATE_ASC)
          comparaison = (e1.getDateStart().getTimeInMillis() < e2.getDateStart().getTimeInMillis() ? -1 : (e1.getDateStart().getTimeInMillis() == e2.getDateStart().getTimeInMillis() ? 0 : 1));
        if (idparam == Evaluation.DATE_DESC)
          comparaison = (e1.getDateStart().getTimeInMillis() < e2.getDateStart().getTimeInMillis() ? 1 : (e1.getDateStart().getTimeInMillis() == e2.getDateStart().getTimeInMillis() ? 0 : -1));
        if (comparaison != 0) return comparaison;
      }
      return 0;
    }
  }
  
}