/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import net.sergecoude.TbiGeneral.*;

public class NiveauDifficulte {
  
  private String _intitule;
  private String _code;
  private int _rang;
  
  public static int RANG_ASC = 0;
  public static int RANG_DESC = 1; 
  
  public NiveauDifficulte(String intitule, String code, int rang) {
    _intitule = intitule;
    _code = code;
    _rang = rang;
  }
  
  public String getIntitule() {
    return _intitule;
  }

  public void setIntitule(String intitule) {
    _intitule = intitule;
  }
  
  public String getCode() {
    return _code;
  }
  
  public int getRang() {
    return _rang;
  }
  
  public String toString() {
    return _intitule;
  }
  
  public static Comparator<NiveauDifficulte> getComparator(ArrayList<ParametreDeTri> paramTri) {
    return new NiveauDifficulteComparator(paramTri);
  }
  
  private static class NiveauDifficulteComparator implements Comparator<NiveauDifficulte> {
    private ArrayList<ParametreDeTri> _parametres;

    private NiveauDifficulteComparator(ArrayList<ParametreDeTri> parametres) {
      _parametres = parametres;
    }

    public int compare(NiveauDifficulte n1, NiveauDifficulte n2) {
      int comparaison = 0;
      for(int i = 0; i < _parametres.size(); i++ ) {
        int idparam = _parametres.get(i).getId();
        if (idparam == NiveauDifficulte.RANG_ASC)
          comparaison = (n1.getRang() < n2.getRang() ? -1 : (n1.getRang() == n2.getRang() ? 0 : 1));
        if (idparam == NiveauDifficulte.RANG_DESC)
          comparaison = (n1.getRang() < n2.getRang() ? 1 : (n1.getRang() == n2.getRang() ? 0 : -1));
        if (comparaison != 0) return comparaison;
      }
      return 0;
    }
  }  
  
}
