/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import net.sergecoude.TbiGeneral.*;
import java.util.*;

public class PanelClasse extends Panneau {

  private final static long serialVersionUID = 1L;

	private bouton _bAjouterEleve, _bEnregistrer;
	private JLabel _texte1, _texte2, _texte3, _texte4;
	private TextField _nom, _nomFichier, _id;
	private JListJButton _listeEleves;
	private JScrollPane _scrollEleves;
	private JPanel _pListeEleves;
	private Classe _classe;
	private DefaultListModel _lesEleves;
  
  public PanelClasse(TbiAdmin app) {
    super(app);
    _police = _police.deriveFont(20f);
    try {
		  _bPrecedent = new bouton(_app.getRessourceByConf("boutonprecedent"));
		  _bPrecedent.addActionListener(this);
		} catch(Exception e) {
		  _app.log(e);
    }
    try {
  		_bAjouterEleve = new bouton(_app.getRessourceByConf("boutonajoutereleve"));
	   	_bAjouterEleve.addActionListener(this);
	  } catch(Exception e) {
	   _app.log(e);
    }
	  try {
      _bEnregistrer = new bouton(app.getRessourceByConf("boutonenregistrer"));
  		_bEnregistrer.addActionListener(this);
  	} catch(Exception e) {
  	 _app.log(e);
    }
		_texte1 = new JLabel("Nom de la classe : ");
		_texte1.setForeground(Color.black);
		_texte1.setFont(_police);
		_nom = new TextField("classe de ");
		_nom.setForeground(Color.black);
		_nom.setFont(_police);
 	  _texte2 = new JLabel("Nombre d'élèves : 0");
		_texte2.setForeground(Color.black);
		_texte2.setFont(_police);
		_texte3 = new JLabel("Nom du fichier : ");
		_texte3.setForeground(Color.black);
		_texte3.setFont(_police);
		_nomFichier = new TextField("");
		_nomFichier.setForeground(Color.black);
		_nomFichier.setFont(_police);
		_texte4 = new JLabel("Identifiant unique de la classe : ");
		_texte4.setForeground(Color.black);
		_texte4.setFont(_police);
		_id = new TextField("");
		_id.setForeground(Color.black);
		_id.setFont(_police);

    _lesEleves = new DefaultListModel();
		_listeEleves = new JListJButton(_lesEleves);
		_listeEleves.setFont(_police);
		_listeEleves.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    _listeEleves.setLayoutOrientation(JList.VERTICAL);
    _listeEleves.setCellRenderer(new EleveCellRenderer());
    _listeEleves.addMouseListener(new JListMouseListener(_listeEleves));
    
		_scrollEleves = new JScrollPane(_listeEleves);
    _scrollEleves.setMinimumSize(new Dimension(800, 350));
    _scrollEleves.setOpaque(false);
    
    Box bMain = Box.createVerticalBox();
    bMain.setOpaque(false);
    setLayout(new BorderLayout());
    JPanel pClasse = new JPanel(new GridLayout(2,2,10,10));
    pClasse.setOpaque(false);
    Box pNom = Box.createHorizontalBox();
    pNom.setOpaque(false);
    pNom.add(_texte1);
    pNom.add(_nom);
    pClasse.add(pNom);
    Box pNbEleves = Box.createHorizontalBox();
    pNbEleves.setOpaque(false);
    pNbEleves.add(_texte2);
    pClasse.add(pNbEleves);
    Box pNomFichier = Box.createHorizontalBox();
    pNomFichier.setOpaque(false);
    pNomFichier.add(_texte3);
    pNomFichier.add(_nomFichier);
    pClasse.add(pNomFichier);
    Box pId = Box.createHorizontalBox();
    pId.setOpaque(false);
    pId.add(_texte4);
    pId.add(_id);
    pClasse.add(pId);
    bMain.add(pClasse);
    bMain.add(Box.createRigidArea(new Dimension(0,10)));
   _pListeEleves = new JPanel(new BorderLayout());
    JLabel lEleves = new JLabel("Les élèves :", JLabel.LEFT);
    lEleves.setFont(_police);
    Box pActions = Box.createVerticalBox();
    pActions.add(_bAjouterEleve);
    pActions.add(_bEnregistrer);
    pActions.add(Box.createVerticalGlue());
    pActions.add(_bPrecedent);
    _pListeEleves.add(lEleves, BorderLayout.NORTH);
    _pListeEleves.add(_scrollEleves, BorderLayout.CENTER);
    _pListeEleves.add(pActions, BorderLayout.EAST);
    bMain.add(_pListeEleves);
    add(bMain);
    bMain.setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
	}
	
	public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bPrecedent) {
			_app.setPanneau("SelectClasse");
		}
		if (source == _bAjouterEleve) {
		  _classe.setNom(_nom.getText().trim());
      ((TbiAdmin)_app).editerEleve(_app.setEleve(new Eleve(_app, _classe)));		  
		}
		if (source == _bEnregistrer) {
		  if (_nomFichier.getText().trim().equals("")) {
		    _app.message("Il faut saisir un nom de fichier...", _app.MESSAGE_ERREUR);
		    return;
      }
		  if (_id.getText().trim().equals("")) {
		    _app.message("Il faut saisir un identifiant unique pour la classe...", _app.MESSAGE_ERREUR);
		    return;
      }
      if (!_app.verifieUniciteIdClasse(_classe, _id.getText())) {
        _app.message("l'identifiant unique de la classe est déjà attribué à une autre...", _app.MESSAGE_AVERTISSEMENT);
        return;
      }
      String chemin = genereNomFichier();
      if (_classe.enregistrer(chemin, _nom.getText(), _id.getText())) {
        ((TbiAdmin)_app).enregistrerClasse(_classe);
        _app.message("Enregistrement de la classe '" + _nom.getText() + "' effectué", _app.MESSAGE_INFORMATION);
      } else {
        _app.message("Problème lors de l'enregistrement de la classe '" + _nom.getText() + "'", _app.MESSAGE_ERREUR);
      }
		} 
	}
	
	public String genereNomFichier() {
    String chemin = _nomFichier.getText().trim();
    if (_nomFichier.getText().indexOf(File.separator) < 0) 
		  chemin = _app.getCheminDesClasses() + File.separator + _nomFichier.getText().trim();
		if (!chemin.toLowerCase().endsWith("-classe.zip"))
      chemin += "-classe.zip";
	  return chemin; 
  }
	
  public void updateListe() {
    _lesEleves.clear();
    if (_classe != null) {
      ArrayList<Eleve> lesEleves = _classe.getLesEleves();
      for(int e = 0; e < lesEleves.size(); e++) 
        _lesEleves.addElement(lesEleves.get(e));
    }  
    _texte2.setText("Nombre d'élèves : " + (_classe != null ? _classe.size() : 0)); 
  }
  
  public void init() {
    _classe = _app.getClasse();
    if (_classe != null) {
      _nom.setText(_classe.getNom());
      _id.setText(_classe.getId());
      if (_classe.getFichier() != null)
        _nomFichier.setText(_classe.getFichier());
      if (_classe.estEnregistree() && !_id.getText().equals(""))
        _id.setEnabled(false);
      else 
        _id.setEnabled(true);
    }
    updateListe();
  }
  
}
 