/*
Copyright Caroline et Serge COUDÉ, (01/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import net.sergecoude.TbiGeneral.*;

public class PanelConfTbi extends Panneau {

  private final static long serialVersionUID = 1L;

  private JRadioButton _brTailleSouris1, _brTailleSouris2, _brTailleSouris3;
  private JRadioButton _brTbiOui, _brTbiNon;
  private JTextField _tfTbiLargeur, _tfTbiHauteur, _tfTbiX, _tfTbiY, _tfCheminDesClasses;
  private JPanel _pConfTbi;
  private bouton _bEnregistrer;
  private bouton _bChoisir;
	
  public PanelConfTbi(TbiAdmin app) {
    super(app);
		
		JPanel pMain = new JPanel(new BorderLayout());
		pMain.setOpaque(false);
		
    Box bMain = Box.createVerticalBox();
    bMain.setOpaque(false);
    setLayout(new BorderLayout());
    
    try {
      _bEnregistrer = new bouton(app.getRessourceByConf("boutonenregistrer"));
		  _bEnregistrer.addActionListener(this);
		} catch (Exception e) {
		  _app.log(e);
    }
    try {
      _bPrecedent = new bouton(app.getRessourceByConf("boutonprecedent"));
		  _bPrecedent.addActionListener(this);
		} catch (Exception e) {
		  _app.log(e);
    }
    try {
      _bChoisir = new bouton(app.getRessourceByConf("boutonchoisir"));
      _bChoisir.addActionListener(this);
    } catch (Exception e) {
      _app.log(e);
    }
    Box pActions = Box.createVerticalBox();
    pActions.add(_bEnregistrer);
    pActions.add(Box.createVerticalGlue());
    pActions.add(_bPrecedent);
    pMain.add(pActions, BorderLayout.EAST);

		_brTailleSouris1 = new JRadioButton("1 (32x32)");
		_brTailleSouris1.setFont(_police);
		_brTailleSouris1.setOpaque(false);
		if (_app.getTailleCurseur() == 1)
      _brTailleSouris1.setSelected(true);
		_brTailleSouris2 = new JRadioButton("2 (64x64)");
		_brTailleSouris2.setFont(_police);
		_brTailleSouris2.setOpaque(false);
		if (_app.getTailleCurseur() == 2)
      _brTailleSouris2.setSelected(true);
		_brTailleSouris3 = new JRadioButton("3 (128x128)");
		_brTailleSouris3.setFont(_police);
		_brTailleSouris3.setOpaque(false);
		if (_app.getTailleCurseur() == 3)
      _brTailleSouris3.setSelected(true);
		
    ButtonGroup groupTailleSouris = new ButtonGroup();
    groupTailleSouris.add(_brTailleSouris1);
    groupTailleSouris.add(_brTailleSouris2);
    groupTailleSouris.add(_brTailleSouris3);

    JPanel pTailleSouris = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pTailleSouris.setOpaque(false);
   
    pTailleSouris.add(_brTailleSouris1);
    pTailleSouris.add(_brTailleSouris2);
    pTailleSouris.add(_brTailleSouris3);
  
    JLabel lCheminDesClasses = new JLabel("Chemin des classes", JLabel.CENTER);
    lCheminDesClasses.setFont(_police);
    lCheminDesClasses.setOpaque(true);
    lCheminDesClasses.setBackground(Color.lightGray);
    lCheminDesClasses.setAlignmentX(Component.CENTER_ALIGNMENT);
    _tfCheminDesClasses = new JTextField("");
    _tfCheminDesClasses.setPreferredSize(new Dimension(450,40));
    _tfCheminDesClasses.setFont(_police);
    JPanel pCheminDesClasses = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pCheminDesClasses.setOpaque(false); 
    pCheminDesClasses.add(_tfCheminDesClasses);
    pCheminDesClasses.add(_bChoisir);
    
    _brTbiOui = new JRadioButton("Oui");
		_brTbiOui.setFont(_police);
		_brTbiOui.setOpaque(false);
		if (_app.getAvecTbi())
      _brTbiOui.setSelected(true);
    _brTbiOui.addActionListener(this);  
    _brTbiNon = new JRadioButton("Non");
		_brTbiNon.setFont(_police);
		_brTbiNon.setOpaque(false);
		if (!_app.getAvecTbi())
      _brTbiNon.setSelected(true);
    _brTbiNon.addActionListener(this);
    
    Font police = new Font("SansSerif", Font.BOLD, 20);
    _pConfTbi = new JPanel(new FlowLayout(FlowLayout.CENTER));
    _pConfTbi.setOpaque(false);
    _tfTbiLargeur = new JTextField(Integer.toString(_app.getLargeurTbi()));
    _tfTbiLargeur.setPreferredSize(new Dimension(60,30));
    _tfTbiLargeur.setFont(police);
    _tfTbiHauteur = new JTextField(Integer.toString(_app.getHauteurTbi()));
    _tfTbiHauteur.setPreferredSize(new Dimension(60,30));
    _tfTbiHauteur.setFont(police);
    _tfTbiX = new JTextField(Integer.toString(_app.getXTbi()));
    _tfTbiX.setPreferredSize(new Dimension(60,30));
    _tfTbiX.setFont(police);
    _tfTbiY = new JTextField(Integer.toString(_app.getYTbi()));
    _tfTbiY.setPreferredSize(new Dimension(60,30));
    _tfTbiY.setFont(police);
    JLabel lX = new JLabel("X:");
    lX.setFont(police); 
    JLabel lY = new JLabel("Y:");
    lY.setFont(police); 
    JLabel lLargeur = new JLabel("Largeur:");
    lLargeur.setFont(police); 
    JLabel lHauteur = new JLabel("Hauteur:");
    lHauteur.setFont(police);
    _pConfTbi.add(lX);
    _pConfTbi.add(_tfTbiX);
    _pConfTbi.add(lY);
    _pConfTbi.add(_tfTbiY);
    _pConfTbi.add(lLargeur);                  
    _pConfTbi.add(_tfTbiLargeur);
    _pConfTbi.add(lHauteur);
    _pConfTbi.add(_tfTbiHauteur);
    
    ButtonGroup groupTbi = new ButtonGroup();
    groupTbi.add(_brTbiOui);
    groupTbi.add(_brTbiNon);
    
    JLabel label3 = new JLabel("Taille de la souris", JLabel.CENTER);
    label3.setFont(_police);
    label3.setOpaque(true);
    label3.setBackground(Color.lightGray);
    label3.setAlignmentX(Component.CENTER_ALIGNMENT);
    pTailleSouris.setAlignmentX(CENTER_ALIGNMENT);
    JLabel label4 = new JLabel("Avec TBI ?", JLabel.CENTER);
    label4.setFont(_police);
    label4.setOpaque(true);
    label4.setBackground(Color.lightGray);
    label4.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel pAvecSansTbi = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pAvecSansTbi.setOpaque(false);
    pAvecSansTbi.add(_brTbiOui);
    pAvecSansTbi.add(_brTbiNon);
    pAvecSansTbi.add(_pConfTbi);
    pAvecSansTbi.setAlignmentX(CENTER_ALIGNMENT);

    bMain.add(Box.createVerticalGlue());
    bMain.add(label3);
    bMain.add(pTailleSouris);
    bMain.add(Box.createVerticalGlue());
    bMain.add(lCheminDesClasses);
    bMain.add(pCheminDesClasses);
    bMain.add(Box.createVerticalGlue());    
    bMain.add(label4);
    bMain.add(pAvecSansTbi);
    bMain.add(Box.createVerticalGlue());
    pMain.add(bMain, BorderLayout.CENTER);
    add(pMain);
    pMain.setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _brTbiOui) {
		  _app.setAvecTbi(true);
		  updateConfTbi();
		}
		if (source == _brTbiNon) {
		  _app.setAvecTbi(false);
      updateConfTbi();		  
		}
		if (source == _bPrecedent) {
		  _app.setPanneau("SelectConfGest");
		}    
		if (source == _bEnregistrer) {
		  try {
        preEnregistrer();
		    _app.sauveConfiguration();
		  } catch (Exception e) {
		    _app.message("Erreur dans l'un des champs...", _app.MESSAGE_AVERTISSEMENT);
      }
		}
		if (source == _bChoisir) {
		  JFileChooser chooser = new JFileChooser(_app.getCheminDesClasses());
		  chooser.setAcceptAllFileFilterUsed(false);
		  chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		  int ret = chooser.showDialog(_app, "Choisir le répertoire contenant les classes");
		  if (ret == JFileChooser.APPROVE_OPTION) {
        File file = chooser.getSelectedFile();
  			_tfCheminDesClasses.setText(file.getAbsolutePath());
      }
      chooser.setSelectedFile(null);      
		}
  }
  
  private void updateConfTbi() {
		if (_app.getAvecTbi()) 
      _pConfTbi.setVisible(true);
    else
      _pConfTbi.setVisible(false);
  }
  
  public void init() {
    if (_app.getConfiguration("tbi").toLowerCase().equals("oui")) {
      _app.setAvecTbi(true);
      _brTbiOui.setSelected(true);
    } else { 
      _app.setAvecTbi(false);
      _brTbiNon.setSelected(true);
    }
    _tfTbiLargeur.setText(_app.getConfiguration("largeur-ecran-tbi"));
    _tfTbiHauteur.setText(_app.getConfiguration("hauteur-ecran-tbi"));
    _tfTbiX.setText(_app.getConfiguration("coordx-ecran-tbi"));
    _tfTbiY.setText(_app.getConfiguration("coordy-ecran-tbi"));
		if (_app.getConfiguration("taillecurseur").equals("1")) {
      _brTailleSouris1.setSelected(true);
      _app.setTailleCurseur(1);
		} else if (_app.getConfiguration("taillecurseur").equals("2")) {
      _brTailleSouris2.setSelected(true);
      _app.setTailleCurseur(2);      
    } else {
      _brTailleSouris3.setSelected(true);
      _app.setTailleCurseur(3);
    }
    _tfCheminDesClasses.setText(_app.getConfiguration("chemindesclasses"));
    updateConfTbi();
  }

  protected void preEnregistrer() throws Exception { // met à jour les config
  	if (_brTailleSouris1.isSelected())
		  _app.setTailleCurseur(1);
		else if (_brTailleSouris2.isSelected())
		  _app.setTailleCurseur(2);
 		else 
 		  _app.setTailleCurseur(3);
		if (_brTbiOui.isSelected())
		  _app.setAvecTbi(true);
		else 
		  _app.setAvecTbi(false);
		_app.setLargeurTbi(Integer.parseInt(_tfTbiLargeur.getText().trim()));
		_app.setHauteurTbi(Integer.parseInt(_tfTbiHauteur.getText().trim()));
		_app.setXTbi(Integer.parseInt(_tfTbiX.getText().trim()));
		_app.setYTbi(Integer.parseInt(_tfTbiY.getText().trim()));
    _app.setCheminDesClasses(_tfCheminDesClasses.getText().trim());
  }  
  
}
