/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import net.sergecoude.TbiGeneral.*;
import java.util.zip.*;
import javax.imageio.*;
import java.net.*;

public class PanelEleve extends Panneau {

  private final static long serialVersionUID = 1L;

  private bouton _bValider, _bPrecedent, _bChoisirPhoto, _bChoisirAudio;
	private JLabel _texte1, _texte2, _texte3, _texte4, _texte5, _texte6, _texte7, _texte8, _texte9;
	private JTextField _nom, _prenom, _nomUsuel, _dateNaissance, _photo, _id, _audio;
	private JComboBox _niveau; 
	private JRadioButton _rbSexeM, _rbSexeF;
	private ButtonGroup _bgSexe;
	private Apercu _apercu;
	private Eleve _eleve = null;
	private boolean _photoChangee;
  private boolean _audioChangee;	
	
  public PanelEleve(TbiAdmin app) {
		super(app);

		_texte1 = new JLabel("Nom de l'élève : ");
		_texte1.setForeground(Color.black);
		_texte1.setFont(_police);
		_nom = new JTextField("");
		_nom.setForeground(Color.black);
		_nom.setFont(_police);
		_texte2 = new JLabel("Prénom de l'élève : ");
		_texte2.setForeground(Color.black);
		_texte2.setFont(_police);
		_prenom = new JTextField("");
		_prenom.setForeground(Color.black);
		_prenom.setFont(_police);
		_texte8 = new JLabel("Nom usuel de l'élève : ");
		_texte8.setForeground(Color.black);
		_texte8.setFont(_police);
		_nomUsuel = new JTextField("");
		_nomUsuel.setForeground(Color.black);
		_nomUsuel.setFont(_police);
		_texte3 = new JLabel("Sexe : ");
		_texte3.setForeground(Color.black);
		_texte3.setFont(_police);
    _bgSexe = new ButtonGroup();
    _rbSexeM = new JRadioButton("Masculin");
    _rbSexeM.setOpaque(false);
    _rbSexeM.setFont(_police);
    _rbSexeF = new JRadioButton("Féminin");
    _rbSexeF.setOpaque(false);
    _rbSexeF.setFont(_police);
    _bgSexe.add(_rbSexeM);
    _bgSexe.add(_rbSexeF);
  	_texte4 = new JLabel("Date de Naissance : ");
		_texte4.setForeground(Color.black);
		_texte4.setFont(_police);
		_dateNaissance = new JTextField("JJ/MM/AAAA");
		_dateNaissance.setForeground(Color.black);
		_dateNaissance.setFont(_police);
  	_texte6 = new JLabel("Niveau : ");
		_texte6.setForeground(Color.black);
		_texte6.setFont(_police);
    _niveau = new JComboBox(_app.getLesNiveaux().values().toArray());
    _niveau.setSelectedIndex(0);
    _niveau.addActionListener(this);
    _niveau.setBackground(Color.white);
    _niveau.setFont(_police);
		_texte5 = new JLabel("Photo : ");
		_texte5.setForeground(Color.black);
		_texte5.setFont(_police);
		_photo = new JTextField("");
		_photo.setForeground(Color.black);
		_photo.setFont(_police);
		_apercu = new Apercu();
		_apercu.setPreferredSize(_app.getDimensionPhoto());
   	_texte7 = new JLabel("identifiant unique : ");
		_texte7.setForeground(Color.black);
		_texte7.setFont(_police);
		_id = new JTextField("");
		_id.setForeground(Color.black);
		_id.setFont(_police);
		_texte9 = new JLabel("Audio : ");
		_texte9.setForeground(Color.black);
		_texte9.setFont(_police);
		_audio = new JTextField("");
		_audio.setForeground(Color.black);
		_audio.setFont(_police);
		
		try {
		    _bPrecedent = new bouton(_app.getRessourceByConf("boutonprecedent"));
		    _bPrecedent.addActionListener(this);
		} catch(Exception e) {
		  _app.log(e);
    }
    try {
		  _bValider = new bouton(_app.getRessourceByConf("boutonvalider"));
		  _bValider.addActionListener(this);
		} catch(Exception e) {
		  _app.log(e);
    }
    try {
		  _bChoisirPhoto = new bouton(_app.getRessourceByConf("boutonchoisir"));
		  _bChoisirPhoto.addActionListener(this);
		} catch (Exception e) {
		  _app.log(e);
    }

    try {
		  _bChoisirAudio = new bouton(_app.getRessourceByConf("boutonchoisir"));
		  _bChoisirAudio.addActionListener(this);
		} catch (Exception e) {
		  _app.log(e);
    }
    JPanel pMain = new JPanel(new BorderLayout(10,10));
    pMain.setOpaque(false);
    JPanel pCentre = new JPanel(new BorderLayout(10,10));
    pCentre.setOpaque(false);
    Box pApercu = Box.createVerticalBox();
    pApercu.setOpaque(false);
    pApercu.add(Box.createVerticalGlue());
    pApercu.add(_apercu);
    pApercu.add(Box.createVerticalGlue());
    pCentre.add(pApercu, BorderLayout.EAST);
    Box pChoix = Box.createVerticalBox();
    pChoix.setOpaque(false);
    Box pPhoto = Box.createHorizontalBox();
    pPhoto.setOpaque(false);
    pPhoto.add(_texte5);
    pPhoto.add(_photo);
    pPhoto.add(Box.createHorizontalStrut(15));
    pPhoto.add(_bChoisirPhoto);
    pPhoto.add(Box.createHorizontalStrut(15));
    pChoix.add(pPhoto);
    pChoix.add(Box.createVerticalStrut(5));
    Box pAudio = Box.createHorizontalBox();
    pAudio.setOpaque(false);
    pAudio.add(_texte9);
    pAudio.add(_audio);
    pAudio.add(Box.createHorizontalStrut(15));
    pAudio.add(_bChoisirAudio);
    pAudio.add(Box.createHorizontalStrut(15));
    pChoix.add(pAudio);
    pCentre.add(pChoix, BorderLayout.SOUTH);
    JPanel pEleve = new JPanel(new GridBagLayout());
    pEleve.setOpaque(false);    
    GridBagConstraints gbcE = new GridBagConstraints();
    gbcE.insets = new Insets(5, 5, 5, 5);
    gbcE.gridx = 0;
    gbcE.gridy = 0;
    gbcE.fill = GridBagConstraints.NONE;
    gbcE.anchor = GridBagConstraints.EAST;
    pEleve.add(_texte1, gbcE);
    gbcE.gridx = 1;
    gbcE.gridy = 0;
    gbcE.fill = GridBagConstraints.HORIZONTAL;    
    gbcE.anchor = GridBagConstraints.WEST;    
    pEleve.add(_nom, gbcE);
    gbcE.gridx = 0;
    gbcE.gridy = 1;
    gbcE.fill = GridBagConstraints.NONE;    
    gbcE.anchor = GridBagConstraints.EAST;    
    pEleve.add(_texte2, gbcE);
    gbcE.gridx = 1;
    gbcE.gridy = 1;
    gbcE.fill = GridBagConstraints.HORIZONTAL;    
    gbcE.anchor = GridBagConstraints.WEST;    
    pEleve.add(_prenom, gbcE);
    gbcE.gridx = 0;
    gbcE.gridy = 2;
    gbcE.fill = GridBagConstraints.NONE;    
    gbcE.anchor = GridBagConstraints.EAST;    
    pEleve.add(_texte8, gbcE);
    gbcE.gridx = 1;
    gbcE.gridy = 2;
    gbcE.fill = GridBagConstraints.HORIZONTAL;    
    gbcE.anchor = GridBagConstraints.WEST;    
    pEleve.add(_nomUsuel, gbcE);
    gbcE.gridx = 0;
    gbcE.gridy = 3;
    gbcE.fill = GridBagConstraints.NONE;    
    gbcE.anchor = GridBagConstraints.EAST;    
    pEleve.add(_texte7, gbcE);
    gbcE.gridx = 1;
    gbcE.gridy = 3;
    gbcE.fill = GridBagConstraints.HORIZONTAL;    
    gbcE.anchor = GridBagConstraints.WEST;    
    pEleve.add(_id, gbcE);    
    gbcE.gridx = 0;
    gbcE.gridy = 4;
    gbcE.fill = GridBagConstraints.NONE;    
    gbcE.anchor = GridBagConstraints.EAST;    
    pEleve.add(_texte3, gbcE);
    JPanel pSexe = new JPanel(new GridLayout(1,2));
    pSexe.setOpaque(false);
    pSexe.add(_rbSexeM);
    pSexe.add(_rbSexeF);
    gbcE.gridx = 1;
    gbcE.gridy = 4;
    gbcE.fill = GridBagConstraints.NONE;    
    gbcE.anchor = GridBagConstraints.WEST;    
    pEleve.add(pSexe, gbcE);
    gbcE.gridx = 0;
    gbcE.gridy = 5;
    gbcE.anchor = GridBagConstraints.EAST;
    gbcE.fill = GridBagConstraints.NONE;        
    pEleve.add(_texte4, gbcE);
    gbcE.gridx = 1;
    gbcE.gridy = 5;
    gbcE.fill = GridBagConstraints.HORIZONTAL;    
    gbcE.anchor = GridBagConstraints.WEST;    
    pEleve.add(_dateNaissance, gbcE);
    gbcE.gridx = 0;
    gbcE.gridy = 6;
    gbcE.fill = GridBagConstraints.NONE;    
    gbcE.anchor = GridBagConstraints.EAST;    
    pEleve.add(_texte6, gbcE);
    gbcE.gridx = 1;
    gbcE.gridy = 6;
    gbcE.fill = GridBagConstraints.HORIZONTAL;    
    gbcE.anchor = GridBagConstraints.WEST;    
    pEleve.add(_niveau, gbcE);
    pCentre.add(pEleve, BorderLayout.CENTER);
    Box pActions = Box.createVerticalBox();
    pActions.add(_bValider);
    pActions.add(Box.createVerticalGlue());
    pActions.add(_bPrecedent);
    pMain.add(pCentre, BorderLayout.CENTER);
    pMain.add(pActions, BorderLayout.EAST);    
            
    setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.fill = GridBagConstraints.NONE;
    add(pMain, gbc);
    setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
	}
	
	public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bPrecedent) {
			_app.setPanneau("PanelClasse");
		}
		if (source == _bValider) {
		  ((TbiAdmin)_app).modification();
		  if (enregistrer())
		    _app.setPanneau("PanelClasse");
		}
		if (source == _bChoisirPhoto) {
		  JFileChooser chooser = new JFileChooser(_app.getCheminDesClasses());
		  chooser.setAcceptAllFileFilterUsed(false);
		  String ext[] = {".jpg", ".png"};
		  chooser.addChoosableFileFilter(new FileNameFilter("Photos", ext));
		  chooser.setAccessory(new ImagePreview(chooser));
		  int ret = chooser.showDialog(_app, "Choisir la photo pour " + _prenom.getText() + " " + _nom.getText());
		  if (ret == JFileChooser.APPROVE_OPTION) {
        File file = chooser.getSelectedFile();
        if (verifieDimension(file)) {
          _photo.setText(file.getAbsolutePath());
          setImage(file.getAbsolutePath());
          _photoChangee = true;
        } else {
          Dimension dim = _app.getDimensionPhoto(); 
          _app.message("L'image ne fait pas " +  dim.width + "x" + dim.height + " pixels", _app.MESSAGE_ERREUR);
        }
      }
      chooser.setSelectedFile(null);      
		}
		if (source == _bChoisirAudio) {
		  JFileChooser chooser = new JFileChooser(_app.getCheminDesClasses());
		  chooser.setAcceptAllFileFilterUsed(false);
		  String ext[] = {".ogg"};
		  chooser.addChoosableFileFilter(new FileNameFilter("Audio", ext));
		  chooser.setAccessory(new ImagePreview(chooser));
		  int ret = chooser.showDialog(_app, "Choisir le fichier audio pour " + _prenom.getText() + " " + _nom.getText());
		  if (ret == JFileChooser.APPROVE_OPTION) {
        File file = chooser.getSelectedFile();
        _audio.setText(file.getAbsolutePath());
        _audioChangee = true;
      }
      chooser.setSelectedFile(null);      
		}
	}
	
	public boolean verifieDimension(File fichier) {
    Dimension dim = _app.getDimensionPhoto();
    try {
      SimpleImageInfo imageInfo = new SimpleImageInfo(fichier);
      return (imageInfo.getWidth() == dim.width &&
              imageInfo.getHeight() == dim.height);
    } catch (IOException ioe) {
      _app.message("Erreur lors de la lecture des dimensions de l'image", _app.MESSAGE_ERREUR);
      _app.log(ioe);
    }
    return false;
  } 
	
	private boolean enregistrer() {
	  String sId = _id.getText();
    String sDn;
    int iDn;
    _id.setText(_id.getText().trim());
    _nom.setText(_nom.getText().trim());
    _prenom.setText(_prenom.getText().trim());
    _nomUsuel.setText(_nomUsuel.getText().trim());
    _photo.setText(_photo.getText().trim());
    // batterie de test de validité
    if (sId != null)
      sId = sId.trim();
	  if (sId.equals("")) {
      _app.message("Il faut obligatoirement saisir un identifiant unique...", _app.MESSAGE_AVERTISSEMENT);
      return false;
    }
    try { 
		  sDn = _dateNaissance.getText().trim();
  		iDn = Integer.parseInt(sDn.substring(6)+sDn.substring(3,5)+sDn.substring(0,2));
  	} catch(Exception e) {
      _app.message("La date de naissance est au mauvais format...", _app.MESSAGE_AVERTISSEMENT);
      return false;
    }
    if (!_app.getClasse().verifieUniciteIdEleve(_eleve, _id.getText())) {
      _app.message("l'identifiant unique de l'élève est déjà attribué à un autre...", _app.MESSAGE_AVERTISSEMENT);
      return false;
    }
    if (_nomUsuel.getText().equals("")) {
      _app.message("Il faut obligatoirement saisir le nom usuel de l'élève...", _app.MESSAGE_AVERTISSEMENT);
      return false;
    }    
    if (!_app.getClasse().verifieUniciteNomUsuelEleve(_eleve, _nomUsuel.getText())) {
      _app.message("le nom usuel de l'élève est déjà attribué à un autre...", _app.MESSAGE_AVERTISSEMENT);
      return false;
    }
    // création et/ou ajout de l'élève
		if (_eleve == null) {
		  _eleve = new Eleve(_app, _app.getClasse(), _id.getText(), _nom.getText(),
                               _prenom.getText(),
                               _nomUsuel.getText(),
                               iDn, 
                               _rbSexeM.isSelected(), 
                               _photo.getText(),
                               _audio.getText(),
                               (Niveau)_niveau.getSelectedItem());
    } else {
        _eleve.setNom(_nom.getText());
        _eleve.setPrenom(_prenom.getText());
        _eleve.setNomUsuel(_nomUsuel.getText());
        _eleve.setId(sId);
        _eleve.setDateNaissance(iDn);
        _eleve.setSexe(_rbSexeM.isSelected());
        if (_photoChangee)
          _eleve.setCheminImage(_photo.getText());
        if (_audioChangee)
          _eleve.setCheminAudio(_audio.getText());
        _eleve.setNiveau((Niveau)_niveau.getSelectedItem());
    }
    _app.setEleve(_eleve);
    _app.getClasse().add(_eleve);
		PanelClasse pClasse = ((TbiAdmin)_app).getPanelClasse();
		pClasse.updateListe();
		return true;
  }
	
  public void setImage(String chemin) {
    if (chemin == null || chemin.equals("")) {
      _apercu.setImage(null);
      return;
    }
    if (chemin.indexOf("file:") >= 0) {
      String nomFichier = chemin.substring(5);
      // il s'agit d'un fichier déjà dans un zip
      try {
        FileInputStream fis = new FileInputStream(_app.getClasse().getFichier());
        BufferedInputStream buffi = new BufferedInputStream(fis);
        ZipInputStream zis = new ZipInputStream(buffi);
        ZipEntry entry;
        byte[] buf = new byte[1024];
        ByteArrayOutputStream bufout = new ByteArrayOutputStream();
        boolean trouve = false;
        while((entry = zis.getNextEntry()) != null) {
          if (entry.getName().equals(nomFichier)) {
            trouve = true;
            int len;
            while ((len = zis.read(buf, 0, 1024)) > 0) {
              bufout.write(buf, 0, len);
            }                      
            zis.close();
            break;                                                                
          }
        }
        InputStream is = new ByteArrayInputStream(bufout.toByteArray());
        _apercu.setImage(ImageIO.read(is));
  		} catch (Exception e) {
  		  _app.message("Impossible de charger la photo...", _app.MESSAGE_ERREUR);
  		  _app.log(e);
  		}
    } else {
      // Il s'agit d'un fichier sur le file system
      File fichierSystem = new File(chemin);
      URL imgUrl = null;
      if (fichierSystem.exists()) {
        try {
          imgUrl = fichierSystem.toURI().toURL();
        } catch(MalformedURLException mfue) {
          _app.log(mfue);
        }        
      } else   
        imgUrl = _app.getRessource(chemin);
      try {
        _apercu.setImage(ImageIO.read(imgUrl));
  		} catch (Exception ioe) {
  		  _app.message("Impossible de charger la photo...", _app.MESSAGE_ERREUR);
  		  _app.log(ioe);
  		}
    }   
  } 

  public void init() {
    _eleve = _app.getEleve();
    if (_eleve != null) {
      _nom.setText(_eleve.getNom());
      _prenom.setText(_eleve.getPrenom());
      _nomUsuel.setText(_eleve.getNomUsuel());
      _dateNaissance.setText(_eleve.getDateNaissanceFormate()); 
      _photo.setText(_eleve.getCheminImage());
      _audio.setText(_eleve.getCheminAudio());
      _niveau.setSelectedItem(_eleve.getNiveau());
      _id.setText(_eleve.getId());      
      if (_eleve.getSexe())
        _rbSexeM .setSelected(true);
      else 
        _rbSexeF.setSelected(true);
      setImage(_eleve.getInterneCheminImage());
      if (_eleve.estEnregistre() && !_id.getText().equals(""))
        _id.setEnabled(false);
      else 
        _id.setEnabled(true);
    } else {
	    _nom.setText("");
	    _prenom.setText("");
	    _nomUsuel.setText("");
	    _rbSexeM.setSelected(false);
	    _rbSexeF.setSelected(false);
	    _dateNaissance.setText("JJ/MM/AAAA");
	    _niveau.setSelectedIndex(0);
	    _photo.setText("");
	    _audio.setText("");
	    _id.setText("");
      setImage(null);
      _id.setEnabled(true);	    
    }
    _photoChangee = false;
    _audioChangee = false;
  } 
  
}
 