/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.event.*;
import java.util.*;
import net.sergecoude.TbiGeneral.*;

public class PanelSelectApplications extends Panneau implements ListSelectionListener, ItemListener, MouseListener, Runnable {

  private final static long serialVersionUID = 1L;

  private JListJButton _listeApplications;
  private JScrollPane _scApplications;
  private JPanel _pConfApplication;
  private JCheckBox _cbApplications;
  private PluginEvaluations _plugin;
  private bouton _bGenerer;
  private JRadioButton _rbTypeGenerationParApplication, _rbTypeGenerationParEleve;
  private ButtonGroup _bgTypeGeneration;
 	
  public PanelSelectApplications(TbiAdmin app) {
    super(app);
    _police = _police.deriveFont(20f);
		_listeApplications = new JListJButton();
		_listeApplications.setFont(_police);
		_listeApplications.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		_listeApplications.setCellRenderer(new ApplicationCellRenderer());
    _listeApplications.setLayoutOrientation(JList.VERTICAL);
    _listeApplications.addListSelectionListener(this);
    _listeApplications.addMouseListener(new JListMouseListener(_listeApplications));
    _listeApplications.addMouseListener(this);    
		_scApplications = new JScrollPane(_listeApplications);
    _scApplications.setOpaque(false);
    _scApplications.setMinimumSize(new Dimension(800, 200));
    _pConfApplication = new JPanel();
    _pConfApplication.setMinimumSize(new Dimension(800, 300));
    _pConfApplication.setOpaque(false);
    _pConfApplication.setLayout(new GridLayout(1,1));
    _cbApplications = new JCheckBox("Toutes");
    _cbApplications.setOpaque(false);
    _cbApplications.setFont(_police);
    _cbApplications.addItemListener(this);
    
    Box pApplications = Box.createVerticalBox();
    Box pApplicationsHaut = Box.createHorizontalBox();
    JLabel lApplications = new JLabel("Choisissez les applications...", JLabel.LEFT);
    lApplications.setFont(_police);
    pApplicationsHaut.add(Box.createHorizontalGlue());
    pApplicationsHaut.add(lApplications);
    pApplicationsHaut.add(Box.createHorizontalGlue());
    pApplicationsHaut.add(_cbApplications);
    pApplicationsHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pApplications.add(pApplicationsHaut);
    _scApplications.setAlignmentX(Component.CENTER_ALIGNMENT);
    pApplications.add(_scApplications);
    
    try {
      _bPrecedent = new bouton(_app.getRessourceByConf("boutonprecedent"));
      _bPrecedent.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bGenerer = new bouton(_app.getRessourceByConf("boutongenerer"));
      _bGenerer.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    Box pBoutons = Box.createHorizontalBox();
    pBoutons.add(Box.createHorizontalGlue());
    pBoutons.add(_bPrecedent);
    pBoutons.add(Box.createHorizontalStrut(30));
    pBoutons.add(_bGenerer);
    pBoutons.add(Box.createHorizontalGlue());

		JPanel pTypeGeneration = new JPanel(new GridLayout(1,2));
    pTypeGeneration.setOpaque(false);
    _rbTypeGenerationParApplication = new JRadioButton("par Application");
    _rbTypeGenerationParApplication.setOpaque(false);
    _rbTypeGenerationParApplication.addItemListener(this);
    _rbTypeGenerationParApplication.setFont(_police);
    pTypeGeneration.add(_rbTypeGenerationParApplication);
    _rbTypeGenerationParEleve = new JRadioButton("par Elève");
    _rbTypeGenerationParEleve.setOpaque(false);
    _rbTypeGenerationParEleve.addItemListener(this);
    _rbTypeGenerationParEleve.setFont(_police);
    pTypeGeneration.add(_rbTypeGenerationParEleve);
    _bgTypeGeneration = new ButtonGroup();
    _bgTypeGeneration.add(_rbTypeGenerationParApplication);
    _bgTypeGeneration.add(_rbTypeGenerationParEleve);

    setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridheight = 2;
    add(pApplications, gbc);
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.gridheight = 1;
    add(pTypeGeneration, gbc);
    gbc.gridx = 0;
    gbc.gridy = 3;
    gbc.gridheight = 4;
    gbc.ipady = 20;
    add(_pConfApplication, gbc);
    gbc.gridx = 0;
    gbc.gridy = 7;
    gbc.gridheight = 1;
    add(pBoutons, gbc);

    _rbTypeGenerationParApplication.setSelected(true);
    
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bPrecedent) {
		 _app.setPanneau("SelectEleves");
		}
		if (source == _bGenerer) {
		 ((TbiAdmin)_app).genererPDF();
		}
  }
  
  public void itemStateChanged(ItemEvent evt) {
    if (_listeApplications.getModel() != null && 
        _listeApplications.getModel().getSize() > 0 &&
        evt.getSource() == _cbApplications)
       selectionneToutesLesApplications(_cbApplications.isSelected());
    if (evt.getSource() == _rbTypeGenerationParApplication && evt.getStateChange() == ItemEvent.SELECTED) 
      ((TbiAdmin)_app).setTypeGeneration(TbiAdmin.TYPE_GENERATION_PAR_APPLICATION);
    if (evt.getSource() == _rbTypeGenerationParEleve && evt.getStateChange() == ItemEvent.SELECTED) 
      ((TbiAdmin)_app).setTypeGeneration(TbiAdmin.TYPE_GENERATION_PAR_ELEVE);
  }
  
  public void valueChanged(ListSelectionEvent evt) {
    if (!evt.getValueIsAdjusting()) {
      if (evt.getSource() == _listeApplications) {
        ItemApplication item = (ItemApplication)_listeApplications.getSelectedValue();
        if (item != null) {
          Application a = item.getApplication();
          if (a != null) {
            _plugin = ((TbiAdmin)_app).getPluginInstance(a);
            _pConfApplication.removeAll();
            _pConfApplication.add(_plugin);
            _plugin.reset();
            _pConfApplication.repaint();
            verifiePossibiliteBoutonGenerer();
          }
        }
      }
    }        
  } 
  
  public void majPlugin(PluginEvaluations plugin) {
    //verifiePossibiliteBoutonGenerer();
  }
    
  private void selectionneToutesLesApplications(boolean selected) {
    ListModel liste = _listeApplications.getModel();
    for(int a = 0; a < liste.getSize(); a++) {
      ItemApplication item = (ItemApplication)liste.getElementAt(a);
      item.setSelected(selected);
      item.repaint();
    }
    _scApplications.repaint();
  }      

  public void verifiePossibiliteBoutonGenerer() {
    ListModel liste = _listeApplications.getModel();
    boolean possible = false;
    for(int a = 0; a < liste.getSize(); a++) {
      ItemApplication item = (ItemApplication)liste.getElementAt(a);
      if (item.isSelected() && item.getApplication().generationPDFPossible()) {
        possible = true;
        break;
      }
    }
    _bGenerer.setVisible(possible);
    revalidate();
  }   
   
  public void agenceLesComposants() {
    Dimension d = getSize();
    int w = 3*d.width/4;
    int h = d.height/4;
    Dimension dListeScroller = new Dimension(w, h);
    _scApplications.setMinimumSize(dListeScroller);
    _scApplications.setMaximumSize(dListeScroller);
    _scApplications.setPreferredSize(dListeScroller);
    Dimension dPanelConf = new Dimension(w, 2*h);
    _pConfApplication.setMinimumSize(dPanelConf);
    _pConfApplication.setMaximumSize(dPanelConf);
    _pConfApplication.setPreferredSize(dPanelConf);
    revalidate();
  }
  
  public void run() {
    try {
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);    
      _listeApplications.setEnabled(false);
      _bGenerer.setEnabled(false);
      ((TbiAdmin)_app).chargeLesApplications();
    } catch(Exception e) {
      _app.message(e, _app.MESSAGE_ERREUR);
    }
    _pConfApplication.removeAll();
    _pConfApplication.repaint();
    // Vecteur -> DefaultListModel
    DefaultListModel listeApplications = new DefaultListModel();
    _listeApplications.setModel(listeApplications);
    Vector<Application> lesApplications = ((TbiAdmin)_app).getLesApplications();
    for(int a = 0; a < lesApplications.size(); a++) {
      Application application = lesApplications.elementAt(a);
      ItemApplication item = new ItemApplication(application);
      item.setPresentDansEvaluation(application.getNbEvaluations() > 0);
      listeApplications.addElement(item);
    }
    _listeApplications.setEnabled(true);
    _bGenerer.setEnabled(true);
    _listeApplications.repaint(); // on force le rafraichissement de la liste
  }
  
  
  public void init() {
    super.init();
    _listeApplications.repaint();
    (new Thread (this)).start();
  }
  
/*  public void majSuivantEvaluations() { // coche l'item si présente dans les évaluations (avec la classe)
    ListModel liste = _listeApplications.getModel();
    for(int a = 0; a < liste.getSize(); a++) {
      ItemApplication item = (ItemApplication)liste.getElementAt(a);
      Application application = item.getApplication();
      System.out.println(item.getApplication().getNom() + " => " + application.getNbEvaluations());
      if (application.getNbEvaluations() > 0) {
        item.setPresenteDansEvaluation(true);
      }
    }
  }*/
  
  public void mouseClicked(MouseEvent evt) {
    //verifiePossibiliteBoutonGenerer();
  }

  public void mouseEntered(MouseEvent evt) {
  }

  public void	mouseExited(MouseEvent evt) {
  }
  
  public void mousePressed(MouseEvent evt) {
  }

  public void	mouseReleased(MouseEvent evt) {
  }

  public Vector<Application> getApplicationsSelectionnees() {
    Vector<Application> res = new Vector<Application>();
    ListModel liste = _listeApplications.getModel();
    for(int a = 0; a < liste.getSize(); a++) {
      ItemApplication item = (ItemApplication)liste.getElementAt(a);
      if (item.isSelected()) 
        res.add(item.getApplication());
      }
    return res;
  } 
}
