/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import net.sergecoude.TbiGeneral.*;

public class PanelSelectClasse extends Panneau {

  private final static long serialVersionUID = 1L;

  private JListJButton _listeClasses;
  private JScrollPane _listeScroller;
  
  private bouton _bCreerClasse;
	
  public PanelSelectClasse(TbiAdmin app) {
    super(app);
		
		_listeClasses = new JListJButton();
		_listeClasses.setFont(_police);
		_listeClasses.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    _listeClasses.setLayoutOrientation(JList.VERTICAL);
    _listeClasses.setCellRenderer(new ClasseCellRenderer());
    _listeClasses.addMouseListener(new JListMouseListener(_listeClasses));

		_listeScroller = new JScrollPane(_listeClasses);
    _listeScroller.setOpaque(false);
    _listeScroller.setMinimumSize(new Dimension(800, 350));
    
    JPanel pListeClasses = new JPanel(new BorderLayout());
    JLabel lClasses = new JLabel("Choisissez la classe...", JLabel.LEFT);
    lClasses.setFont(_police);
    try {
      _bCreerClasse = new bouton(_app.getRessourceByConf("boutoncreerclasse"));
      _bCreerClasse.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bPrecedent = new bouton(_app.getRessourceByConf("boutonprecedent"));
      _bPrecedent.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    Box bActions = Box.createVerticalBox();
    bActions.add(_bCreerClasse);
    bActions.add(Box.createVerticalGlue());
    bActions.add(_bPrecedent);
    pListeClasses.add(lClasses, BorderLayout.NORTH);
    pListeClasses.add(_listeClasses, BorderLayout.CENTER);
    pListeClasses.add(bActions, BorderLayout.EAST);

    Box bMain = Box.createVerticalBox();
    bMain.setOpaque(false);
    setLayout(new BorderLayout());
    bMain.add(pListeClasses);        
    add(bMain);
    bMain.setBorder(BorderFactory.createEmptyBorder(40,60,40,60));
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bCreerClasse) {
		  ((TbiAdmin)_app).editerClasse(_app.setClasse(new Classe(_app)));
		}
		if (source == _bPrecedent) {
		 _app.setPanneau("SelectConfGest");
		}
  }
  
  public void agenceLesComposants() {
    Dimension d = getSize();
    int w = 3*d.width/4;
    int h = d.height/2;
    Dimension dListeScroller = new Dimension(w, h);
    _listeScroller.setMinimumSize(dListeScroller);
    _listeScroller.setMaximumSize(dListeScroller);
    _listeScroller.setPreferredSize(dListeScroller);
    // maj de la police
    float surf = 1024 * 768;
    float surfTbi = _app.getLargeurTbi() * _app.getHauteurTbi();
    float ratio = (float)Math.sqrt(surfTbi / surf);
    if (ratio > 1)
      ratio = 1;
    int hauteurItem = (int)(_hauteurPolice*2*ratio);
    _listeClasses.setFixedCellHeight(hauteurItem);
    _listeClasses.revalidate();
    _listeScroller.revalidate();
    _bPrecedent.setRatio(ratio);
    revalidate();
  }
  
  public void init() {
    super.init();
    if (_app.getLesClasses() == null)
      _app.chargeLesClasses(this);
    _listeClasses.setModel(_app.getLesClasses());
  }

  public void setEnabled(boolean enabled) {
    _listeClasses.setEnabled(enabled);
    DefaultListModel lesClasses = _app.getLesClasses();
    if (lesClasses != null)
      for(int i = 0; i < lesClasses.size(); i++) { 
        ItemClasseGen item = ((Classe)lesClasses.elementAt(i)).getItemClasse();
        item.setEnabled(enabled);
      }
  }
  
}
