/*
Copyright Caroline et Serge COUDÉ, (03/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import net.sergecoude.TbiGeneral.*;

public class PanelSelectConfGest extends JPanel implements ActionListener {

  private final static long serialVersionUID = 1L;

  private TbiAdmin _app;
  private Font _police = new Font("SansSerif", Font.BOLD, 30);
  private bouton _bGestionClasse;
  private bouton _bConf;
  private bouton _bEvaluations;
  private bouton _bSauvegarde;
  private bouton _bRestauration;
	
  public PanelSelectConfGest(TbiAdmin app) {
    _app = app;
		setBackground(Color.gray);
		
		try {
      _bGestionClasse = new bouton(_app.getRessourceByConf("boutongestionclasse"));
      _bGestionClasse.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bConf = new bouton(_app.getRessourceByConf("boutonconfiguration"));
      _bConf.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bEvaluations = new bouton(_app.getRessourceByConf("boutonevaluations"));
      _bEvaluations.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bSauvegarde = new bouton(_app.getRessourceByConf("boutonsauvegarde"));
      _bSauvegarde.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bRestauration = new bouton(_app.getRessourceByConf("boutonrestauration"));
      _bRestauration.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }

    Box bMain = Box.createVerticalBox();
    bMain.setOpaque(false);
    setLayout(new BorderLayout());
    
    JPanel pSauvegardeRestauration = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pSauvegardeRestauration.setOpaque(false);
    pSauvegardeRestauration.add(_bSauvegarde);
    pSauvegardeRestauration.add(_bRestauration);
    
    bMain.add(Box.createVerticalGlue());
    bMain.add(_bConf);
    bMain.add(Box.createVerticalGlue());
    bMain.add(_bGestionClasse);
    bMain.add(Box.createVerticalGlue());
    bMain.add(_bEvaluations);
    bMain.add(Box.createVerticalGlue());
    bMain.add(pSauvegardeRestauration);
    bMain.add(Box.createVerticalGlue());
    add(bMain);
    bMain.setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bConf) {
		  _app.setPanneau("ConfTbi");
		}
		if (source == _bGestionClasse) {
		  _app.setPanneau("SelectClasse");
		}
		if (source == _bEvaluations) {
		  _app.setPanneau("SelectEleves");
		}
		if (source == _bSauvegarde) {
		  JFileChooser chooser = new JFileChooser(".");
		  chooser.setAcceptAllFileFilterUsed(false);
		  chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		  int ret = chooser.showDialog(_app, "Choisir le répertoire pour la sauvegarde");
		  if (ret == JFileChooser.APPROVE_OPTION) {
        _app.sauvegarde(chooser.getSelectedFile());
      }
      chooser.setSelectedFile(null);      
		}		
		if (source == _bRestauration) {
		  JFileChooser chooser = new JFileChooser(".");
		  chooser.setAcceptAllFileFilterUsed(false);
		  chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		  int ret = chooser.showDialog(_app, "Choisir le répertoire contenant la sauvegarde");
		  if (ret == JFileChooser.APPROVE_OPTION) {
        _app.restauration(chooser.getSelectedFile());
      }
      chooser.setSelectedFile(null);      
		}		
  }
}
