/*
Copyright Caroline et Serge COUDÉ, (03/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.event.*;
import java.util.*;
import net.sergecoude.TbiGeneral.*;

public class PanelSelectEleves extends Panneau implements ListSelectionListener, ItemListener {

  private final static long serialVersionUID = 1L;

  private JList _listeClasses, _listeEleves;
  private JScrollPane _scClasses, _scEleves;
  private JCheckBox _cbEleves;
  private bouton _bSuivant;
  private JRadioButton _rbPresentNonPresent, _rbNonPresentPresent;
  private JRadioButton _rbNomAZ, _rbNomZA;
	private JRadioButton _rbPrenomAZ, _rbPrenomZA;
	private ButtonGroup _bgPresence, _bgNom, _bgPrenom, _bgNomUsuel, _bgSexe, _bgDateNaissance, _bgNiveau;
	private JRadioButton _rbDateNaissance09, _rbDateNaissance90;
	private JRadioButton _rbNomUsuelAZ, _rbNomUsuelZA;
	private JRadioButton _rbSexeMF, _rbSexeFM;
	private JRadioButton _rbNiveauPG, _rbNiveauGP;
	private bouton _bReinitialiser; 
	private Classe _classeSelectionnee = null;
	private ArrayList<ParametreDeTri> _lesParametresDeTri = new ArrayList<ParametreDeTri>();
  
  public PanelSelectEleves(TbiAdmin app) {
    super(app);
    _police = _police.deriveFont(20f);
		_listeClasses = new JList();
		_listeClasses.setFont(_police);
		_listeClasses.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    _listeClasses.setLayoutOrientation(JList.VERTICAL);
    _listeClasses.addListSelectionListener(this);
		_scClasses = new JScrollPane(_listeClasses);
    _scClasses.setOpaque(false);
    _scClasses.setMinimumSize(new Dimension(800, 200));
		_listeEleves = new JList();
		_listeEleves.setFont(_police);
		_listeEleves.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
    _listeEleves.setLayoutOrientation(JList.VERTICAL);
    _listeEleves.addListSelectionListener(this);
    _listeEleves.setCellRenderer(new EleveCellRenderer(false));   
		_scEleves = new JScrollPane(_listeEleves);
    _scEleves.setOpaque(false);
    _scEleves.setMinimumSize(new Dimension(800, 300));
    _cbEleves = new JCheckBox("Tous");
    _cbEleves.setOpaque(false);
    _cbEleves.setFont(_police);
    _cbEleves.addItemListener(this);
    
		JPanel pTris = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pTris.setOpaque(true);
		pTris.setBackground(new Color(190,190,190));
		JPanel pTriPresence = new JPanel(new GridLayout(2,1));
    pTriPresence.setOpaque(false);
    pTriPresence.setPreferredSize(new Dimension(ItemEleve.lPresent, ItemEleve.hPresent));
    pTris.add(pTriPresence);
    _rbPresentNonPresent = new JRadioButton("P");
    _rbPresentNonPresent.setOpaque(false);
    _rbPresentNonPresent.addItemListener(this);
    pTriPresence.add(_rbPresentNonPresent);
    _rbNonPresentPresent = new JRadioButton("A");
    _rbNonPresentPresent.setOpaque(false);
    _rbNonPresentPresent.addItemListener(this);
    _bgPresence = new ButtonGroup();
    _bgPresence.add(_rbPresentNonPresent);
    _bgPresence.add(_rbNonPresentPresent);
    pTriPresence.add(_rbNonPresentPresent);
		JPanel pTriNom = new JPanel(new GridLayout(2,1));
    pTriNom.setOpaque(false);
    pTriNom.setPreferredSize(new Dimension(ItemEleve.lNom, ItemEleve.hNom));
    pTris.add(pTriNom);
    _rbNomAZ = new JRadioButton("A->Z");
    _rbNomAZ.setOpaque(false);
    _rbNomAZ.addItemListener(this);
    pTriNom.add(_rbNomAZ);
    _rbNomZA = new JRadioButton("Z->A");
    _rbNomZA.setOpaque(false);
    _rbNomZA.addItemListener(this);
    _bgNom = new ButtonGroup();
    _bgNom.add(_rbNomAZ);
    _bgNom.add(_rbNomZA);
    pTriNom.add(_rbNomZA);
		JPanel pTriPrenom = new JPanel(new GridLayout(2,1));
    pTriPrenom.setOpaque(false);
    pTriPrenom.setPreferredSize(new Dimension(ItemEleve.lPrenom, ItemEleve.hPrenom));
    pTris.add(pTriPrenom);
    _rbPrenomAZ = new JRadioButton("A -> Z");
    _rbPrenomAZ.setOpaque(false);
    _rbPrenomAZ.addItemListener(this);
    pTriPrenom.add(_rbPrenomAZ);
    _rbPrenomZA = new JRadioButton("Z -> A");
    _rbPrenomZA.setOpaque(false);
    _rbPrenomZA.addItemListener(this);
    _bgPrenom = new ButtonGroup();
    _bgPrenom.add(_rbPrenomAZ);
    _bgPrenom.add(_rbPrenomZA);
    pTriPrenom.add(_rbPrenomZA);
		JPanel pTriNomUsuel = new JPanel(new GridLayout(2,1));
    pTriNomUsuel.setOpaque(false);
    pTriNomUsuel.setPreferredSize(new Dimension(ItemEleve.lNomUsuel, ItemEleve.hNomUsuel));
    pTris.add(pTriNomUsuel);
    _rbNomUsuelAZ = new JRadioButton("A->Z");
    _rbNomUsuelAZ.setOpaque(false);
    _rbNomUsuelAZ.addItemListener(this);
    pTriNomUsuel.add(_rbNomUsuelAZ);
    _rbNomUsuelZA = new JRadioButton("Z->A");
    _rbNomUsuelZA.setOpaque(false);
    _rbNomUsuelZA.addItemListener(this);
    pTriNomUsuel.add(_rbNomUsuelZA);
    _bgNomUsuel = new ButtonGroup();
    _bgNomUsuel.add(_rbNomUsuelAZ);
    _bgNomUsuel.add(_rbNomUsuelZA);
		JPanel pTriSexe = new JPanel(new GridLayout(2,1));
    pTriSexe.setOpaque(false);
    pTriSexe.setPreferredSize(new Dimension(ItemEleve.lSexe, ItemEleve.hSexe));
    pTris.add(pTriSexe);
    _rbSexeMF = new JRadioButton("M->F");
    _rbSexeMF.setOpaque(false);
    _rbSexeMF.addItemListener(this);
    pTriSexe.add(_rbSexeMF);
    _rbSexeFM = new JRadioButton("F->M");
    _rbSexeFM.setOpaque(false);
    _rbSexeFM.addItemListener(this);
    pTriSexe.add(_rbSexeFM);
    _bgSexe = new ButtonGroup();
    _bgSexe.add(_rbSexeMF);
    _bgSexe.add(_rbSexeFM);
    JPanel pTriDateNaissance = new JPanel(new GridLayout(2,1));
    pTriDateNaissance.setOpaque(false);
    pTris.add(pTriDateNaissance);
    _rbDateNaissance09 = new JRadioButton("Jeune -> Age");
    _rbDateNaissance09.setOpaque(false);
    _rbDateNaissance09.addItemListener(this);
    pTriDateNaissance.add(_rbDateNaissance09);
    _rbDateNaissance90 = new JRadioButton("Age -> Jeune");
    _rbDateNaissance90.setOpaque(false);
    _rbDateNaissance90.addItemListener(this);
    _bgDateNaissance = new ButtonGroup();
    _bgDateNaissance.add(_rbDateNaissance09);
    _bgDateNaissance.add(_rbDateNaissance90);
    pTriDateNaissance.add(_rbDateNaissance90);
    pTriDateNaissance.setPreferredSize(new Dimension(ItemEleve.lDateNaissance, ItemEleve.hDateNaissance));
		JPanel pTriNiveau = new JPanel(new GridLayout(2,1));
    pTriNiveau.setOpaque(false);
    pTriNiveau.setPreferredSize(new Dimension(ItemEleve.lNiveau, ItemEleve.hNiveau));
    pTris.add(pTriNiveau);
    _rbNiveauPG = new JRadioButton("P->G");
    _rbNiveauPG.setOpaque(false);
    _rbNiveauPG.addItemListener(this);
    pTriNiveau.add(_rbNiveauPG);
    _rbNiveauGP = new JRadioButton("G->P");
    _rbNiveauGP.setOpaque(false);
    _rbNiveauGP.addItemListener(this);
    pTriNiveau.add(_rbNiveauGP);
    _bgNiveau = new ButtonGroup();
    _bgNiveau.add(_rbNiveauPG);
    _bgNiveau.add(_rbNiveauGP);
    
    Box pClasses = Box.createVerticalBox();
    JLabel lClasses = new JLabel("Choisissez la classe...", JLabel.LEFT);
    lClasses.setFont(_police);
    lClasses.setAlignmentX(Component.CENTER_ALIGNMENT);
    pClasses.add(lClasses);
    _scClasses.setAlignmentX(Component.CENTER_ALIGNMENT);
    pClasses.add(_scClasses);
    
    Box pEleves = Box.createVerticalBox();
    Box pElevesHaut = Box.createHorizontalBox();
    JLabel lEleves = new JLabel("Choisissez les élèves...", JLabel.LEFT);
    lEleves.setFont(_police);
    pElevesHaut.add(Box.createHorizontalGlue());
    pElevesHaut.add(lEleves);
    pElevesHaut.add(Box.createHorizontalGlue());
    pElevesHaut.add(_cbEleves);
    pElevesHaut.setAlignmentX(Component.CENTER_ALIGNMENT);
    pEleves.add(pElevesHaut);
    JPanel pElevesBas = new JPanel(new BorderLayout());
    pElevesBas.add(pTris, BorderLayout.NORTH);
    pElevesBas.add(_scEleves, BorderLayout.CENTER);
    pElevesBas.setAlignmentX(Component.CENTER_ALIGNMENT);
    pEleves.add(pElevesBas);

    Box pBoutons = Box.createHorizontalBox();
    pBoutons.add(Box.createHorizontalGlue());
    try {
      _bPrecedent = new bouton(_app.getRessourceByConf("boutonprecedent"));
      _bPrecedent.addActionListener(this);
      pBoutons.add(_bPrecedent);
      pBoutons.add(Box.createHorizontalStrut(30));
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bSuivant = new bouton(_app.getRessourceByConf("boutonsuivant"));
      _bSuivant.addActionListener(this);
      pBoutons.add(_bSuivant);
      pBoutons.add(Box.createHorizontalGlue());
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bReinitialiser = new bouton(_app.getRessourceByConf("boutonreinitialiser"));
      _bReinitialiser.addActionListener(this);
      pTris.add(_bReinitialiser);
    } catch(Exception e) {
      _app.log(e);
    }
    
    setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridheight = 2;
    add(pClasses, gbc);
    gbc.gridx = 0;
    gbc.gridy = 2;
    gbc.ipady = 20;
    gbc.gridheight = 4;
    add(pEleves, gbc);
    gbc.gridx = 0;
    gbc.gridy = 6;
    gbc.gridheight = 1;
    add(pBoutons, gbc);
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bPrecedent) {
		 _app.setPanneau("SelectConfGest");
		}
		if (source == _bSuivant) {
		 _app.setPanneau("SelectApplications");
		}
		if (source == _bReinitialiser) {
		  _lesParametresDeTri.clear();
      _bgPresence.clearSelection();
      _bgNom.clearSelection();
      _bgPrenom.clearSelection();
      _bgNomUsuel.clearSelection();
      _bgSexe.clearSelection();
      _bgDateNaissance.clearSelection();
      _bgNiveau.clearSelection();
      if (_classeSelectionnee != null) 
        majListeEleves(_classeSelectionnee.getLesEleves());
		}
  }
  
  public void valueChanged(ListSelectionEvent evt) {
    if (!evt.getValueIsAdjusting()) {
      if (evt.getSource() == _listeClasses) {
        _classeSelectionnee = (Classe)_listeClasses.getSelectedValue();
        if (_classeSelectionnee != null) 
          majListeEleves(_classeSelectionnee.getLesEleves());
          if (_cbEleves.isSelected()) 
            _cbEleves.setSelected(false);
          _cbEleves.setSelected(true); // on sélectionne par défaut tous les élèves
      } else if (evt.getSource() == _listeEleves) {
      }
      verifiePossibiliteBoutonSuivant();
    }
  }
  
  public void itemStateChanged(ItemEvent evt) {
    if (_listeEleves.getModel() != null && 
        _listeEleves.getModel().getSize() > 0) {
      if (evt.getSource() == _cbEleves)
        selectionneTousLesEleves(_cbEleves.isSelected());
      if (evt.getSource() == _rbPresentNonPresent && evt.getStateChange() == ItemEvent.SELECTED) 
        ajouteParametreDeTri(Eleve.PRESENT_DESC, Eleve.PRESENT_ASC);
      if (evt.getSource() == _rbNonPresentPresent && evt.getStateChange() == ItemEvent.SELECTED) 
        ajouteParametreDeTri(Eleve.PRESENT_ASC, Eleve.PRESENT_DESC);
      if (evt.getSource() == _rbNomAZ && evt.getStateChange() == ItemEvent.SELECTED) 
        ajouteParametreDeTri(Eleve.NOM_ASC, Eleve.NOM_DESC);
      if (evt.getSource() == _rbNomZA && evt.getStateChange() == ItemEvent.SELECTED) 
        ajouteParametreDeTri(Eleve.NOM_DESC, Eleve.NOM_ASC);
      if (evt.getSource() == _rbPrenomAZ && evt.getStateChange() == ItemEvent.SELECTED) 
        ajouteParametreDeTri(Eleve.PRENOM_ASC, Eleve.PRENOM_DESC);
      if (evt.getSource() == _rbPrenomZA && evt.getStateChange() == ItemEvent.SELECTED) 
        ajouteParametreDeTri(Eleve.PRENOM_DESC, Eleve.PRENOM_ASC);
      if (evt.getSource() == _rbNomUsuelAZ && evt.getStateChange() == ItemEvent.SELECTED) 
        ajouteParametreDeTri(Eleve.NOMUSUEL_ASC, Eleve.NOMUSUEL_DESC);
      if (evt.getSource() == _rbNomUsuelZA && evt.getStateChange() == ItemEvent.SELECTED)
        ajouteParametreDeTri(Eleve.NOMUSUEL_DESC, Eleve.NOMUSUEL_ASC);      
      if (evt.getSource() == _rbSexeMF && evt.getStateChange() == ItemEvent.SELECTED)
        ajouteParametreDeTri(Eleve.SEXE_ASC, Eleve.SEXE_DESC);
      if (evt.getSource() == _rbSexeFM && evt.getStateChange() == ItemEvent.SELECTED)
        ajouteParametreDeTri(Eleve.SEXE_DESC, Eleve.SEXE_ASC);
      if (evt.getSource() == _rbDateNaissance09 && evt.getStateChange() == ItemEvent.SELECTED)
        ajouteParametreDeTri(Eleve.DNAISSANCE_DESC, Eleve.DNAISSANCE_ASC);
      if (evt.getSource() == _rbDateNaissance90 && evt.getStateChange() == ItemEvent.SELECTED)
        ajouteParametreDeTri(Eleve.DNAISSANCE_ASC, Eleve.DNAISSANCE_DESC);
      if (evt.getSource() == _rbNiveauPG && evt.getStateChange() == ItemEvent.SELECTED)
        ajouteParametreDeTri(Eleve.NIVEAU_ASC, Eleve.NIVEAU_DESC);
      if (evt.getSource() == _rbNiveauGP && evt.getStateChange() == ItemEvent.SELECTED)
        ajouteParametreDeTri(Eleve.NIVEAU_DESC, Eleve.NIVEAU_ASC);
    } 
  }
  
  private void ajouteParametreDeTri(int paramAAjouter, int paramASupprimer) {
    for(int i = 0; i < _lesParametresDeTri.size(); i++) {
      ParametreDeTri param = _lesParametresDeTri.get(i);
      if (param.getId() == paramAAjouter)
        return;
      if (param.getId() == paramASupprimer) {
        _lesParametresDeTri.remove(i);
        break;
      }
   }
    _lesParametresDeTri.add(new ParametreDeTri(paramAAjouter,""));
    ArrayList<Eleve> liste = _classeSelectionnee.tri(Eleve.getComparator(_lesParametresDeTri)); 
    majListeEleves(liste);
  }  
  
  private void majListeEleves(ArrayList<Eleve> liste) {
    DefaultListModel lEleves = new DefaultListModel();
    for(int e = 0; e < liste.size(); e++)
      lEleves.addElement(liste.get(e));
    _listeEleves.setModel(lEleves);
  }
  
  private void selectionneTousLesEleves(boolean selected) {
    ListModel liste = _listeEleves.getModel();
    if (selected) 
      _listeEleves.setSelectionInterval(0, liste.getSize()-1);
    else
      _listeEleves.setSelectedIndices(new int[] {});
    verifiePossibiliteBoutonSuivant();  
  }
  
  public Vector<Eleve> getElevesSelectionnes() {
    Object []lesEleves = _listeEleves.getSelectedValues();
    Vector<Eleve> res = new Vector<Eleve>();
    if (lesEleves != null)
      for(int e = 0; e < lesEleves.length; e++)
        res.add((Eleve)lesEleves[e]);
    return res; 
  }
  
  public Classe getClasseSelectionnee() {
    return (Classe)_listeClasses.getSelectedValue();
  }       

  private void verifiePossibiliteBoutonSuivant() {
    if (_listeEleves.getSelectedIndex() > -1)         
      _bSuivant.setVisible(true);
    else
      _bSuivant.setVisible(false); 
  } 
  
  public void agenceLesComposants() {
    Dimension d = getSize();
    int w = 3*d.width/4;
    int h = d.height/3;
    Dimension dListeClasses = new Dimension(w, h/2);
    Dimension dListeEleves = new Dimension(w, h);
    _scClasses.setMinimumSize(dListeClasses);
    _scClasses.setMaximumSize(dListeClasses);
    _scClasses.setPreferredSize(dListeClasses);
    _scEleves.setMinimumSize(dListeEleves);
    _scEleves.setMaximumSize(dListeEleves);
    _scEleves.setPreferredSize(dListeEleves);
    revalidate();  
  }
  
  public void init() {
    super.init();
    if (_app.getLesClasses() == null)
      _app.chargeLesClasses(this);
    _listeClasses.setModel(_app.getLesClasses());
    _listeEleves.setModel(new DefaultListModel());
	  verifiePossibiliteBoutonSuivant(); 
  }

  public void setEnabled(boolean enabled) {
    _listeClasses.setEnabled(enabled);
    DefaultListModel lesClasses = _app.getLesClasses();
    if (lesClasses != null)
      for(int i = 0; i < lesClasses.size(); i++) { 
        ItemClasseGen item = ((Classe)lesClasses.elementAt(i)).getItemClasse();
        item.setEnabled(enabled);
      }
  }
  
}
