/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiAdmin;

import javax.swing.*;
import java.net.*;
import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import org.jfree.data.category.*;
import com.itextpdf.text.*;
import com.itextpdf.text.pdf.*;
import net.sergecoude.TbiGeneral.*;

public class PluginEvaluations extends JPanel implements ListSelectionListener, ItemListener, MouseListener {

  private final static long serialVersionUID = 1L;

  protected Vector<Eleve> _lesElevesSelectionnes = null;
  protected Classe _laClasseSelectionnee = null;
  protected TbiApp _app = null;
  protected Application _application = null;
  protected ItemApplication _itemApplication = null;
  protected JCheckBox _cbMires = null, _cbTemps = null, _cbReponses = null;
  protected BaseColor _couleurFondTitre = new BaseColor(230,230,230);
  protected java.awt.Font _police = new java.awt.Font("SansSerif", java.awt.Font.BOLD, 17);
  protected java.awt.Font _policeLibelle = new java.awt.Font("SansSerif", java.awt.Font.BOLD, 17);
  protected DefaultListModel _lesNiveauxDifficulte = null;
  protected JListJButton _listeNiveaux = null;
  protected JScrollPane _scNiveaux = null;
  protected JCheckBox _cbNiveaux = null, _cbEvaluations = null;
  protected bouton _bMires = null, _bTemps = null, _bReponses = null;
  protected JListJButton _listeEvaluations = null;
  protected JScrollPane _scEvaluations = null;
  protected String _nomApplication = "TbiApplication 1.0"; 
  protected int _nbEvaluations = 10;
  protected com.itextpdf.text.Font _policePDFReponses = FontFactory.getFont(FontFactory.HELVETICA, 8, com.itextpdf.text.Font.NORMAL);
  protected HashMap<String, Skin> _lesSkins = null;

  public PluginEvaluations() {
    super();
    try {
      setOpaque(false);
      _listeNiveaux = new JListJButton();
      _listeNiveaux.setFont(_police);
      _listeNiveaux.addListSelectionListener(this);
      _listeNiveaux.addMouseListener(new JListMouseListener(_listeNiveaux));
      _listeNiveaux.addMouseListener(this);    
      _listeNiveaux.setCellRenderer(new NiveauDifficulteCellRenderer());
      _scNiveaux = new JScrollPane(_listeNiveaux);
      _listeEvaluations = new JListJButton();
      _listeEvaluations.setFont(_police);
      _listeEvaluations.addListSelectionListener(this);
      _listeEvaluations.addMouseListener(new JListMouseListener(_listeEvaluations));
      _listeEvaluations.addMouseListener(this);    
      _listeEvaluations.setCellRenderer(new EvaluationCellRenderer());
      _scEvaluations = new JScrollPane(_listeEvaluations);
    
      _cbNiveaux = new JCheckBox("Tous");
      _cbNiveaux.setOpaque(false);
      _cbNiveaux.setFont(_policeLibelle);
      _cbNiveaux.addItemListener(this);
      _cbEvaluations = new JCheckBox("Toutes");
      _cbEvaluations.setOpaque(false);
      _cbEvaluations.setFont(_policeLibelle);
      _cbEvaluations.addItemListener(this);
  
      _cbMires = new JCheckBox();
      _cbMires.setOpaque(false);
      _cbMires.setFont(_policeLibelle);
      _cbMires.addItemListener(this);
      _cbMires.setSelected(true);
      _cbTemps = new JCheckBox();
      _cbTemps.setOpaque(false);
      _cbTemps.setFont(_policeLibelle);
      _cbTemps.addItemListener(this);
      _cbReponses = new JCheckBox();
      _cbReponses.setOpaque(false);
      _cbReponses.setFont(_policeLibelle);
      _cbReponses.addItemListener(this);
    } catch(Exception e) {
      e.printStackTrace();
    }
    _lesSkins = new HashMap<String, Skin>();       
  }
  
  public void init(TbiApp app, Application application) {
    _app = app;
    _application = application;
    setClasseSelectionnee(_app.getClasseSelectionnee());
    setElevesSelectionnes(_app.getElevesSelectionnes());
  }
  
  public void reset() {
  }
  
  protected JComponent creePanneauTypesGraphiques() {
    Box pTypesGraphiques = Box.createVerticalBox();
    pTypesGraphiques.add(Box.createVerticalGlue());
    JPanel pMires = new JPanel();
    pMires.setOpaque(false);
    pMires.add(_cbMires);
    try {
      _bMires = new bouton(((TbiAdmin)_app).getRessourceByConf("mires"));
    } catch(Exception e) {
      ((TbiAdmin)_app).log(e);
    }
    pMires.add(_bMires);
    pTypesGraphiques.add(pMires);
    JPanel pTemps = new JPanel();
    pTemps.setOpaque(false);
    pTemps.add(_cbTemps);
    try {
      _bTemps = new bouton(((TbiAdmin)_app).getRessourceByConf("temps"));
    } catch(Exception e) {
     ((TbiAdmin)_app).log(e);
    }
    pTemps.add(_bTemps);
    pTypesGraphiques.add(pTemps);
    JPanel pReponses = new JPanel();
    pReponses.setOpaque(false);
    pReponses.add(_cbReponses);
    try {
      _bReponses = new bouton(((TbiAdmin)_app).getRessourceByConf("reponses"));
    } catch(Exception e) {
      ((TbiAdmin)_app).log(e);
    }
    pReponses.add(_bReponses);
    pTypesGraphiques.add(pReponses);
    pTypesGraphiques.add(Box.createVerticalGlue()); 
    return pTypesGraphiques; 
  }
  
  protected Vector<ItemNiveauDifficulte> creeLesItemsNiveauxDifficulte() {
    Vector<ItemNiveauDifficulte> lesItemsNiveauxDifficulte = new Vector<ItemNiveauDifficulte>();
    return lesItemsNiveauxDifficulte;
  }    

  public Vector<ItemEvaluation> getLesItemsEvaluationsSelectionnes(boolean selected) {
    return null;
  }

  protected void genereDataset(Evaluation eval, Eleve eleve, DefaultCategoryDataset dataset, int rang) {
    String dateEvaluation = formateDate(eval.getDateStart()) + (rang == 0 ? "" : "-"+rang);
    Vector<Epreuve> lesEpreuves = eval.getLesEpreuves();
    for(int a = 0; a < lesEpreuves.size(); a++) {
      Epreuve ep = lesEpreuves.elementAt(a);
      if (ep.getEleve().getId().equals(eleve.getId())) {
        Vector<Exercice> lesExercices = ep.getLesExercices();
        for(int b = 0; b < lesExercices.size(); b++) {
          Exercice ex = lesExercices.elementAt(b);
          Vector<Enregistrement> lesEnregistrements = ex.getLesEnregistrements();
          for(int c = 0; c < lesEnregistrements.size(); c++) {
            Enregistrement enr = lesEnregistrements.elementAt(c);
            if (enr.estUnSucces()) {
              dataset.addValue((float)enr.getDuree()/1000f, eleve.getNomUsuel(), dateEvaluation + "[" + ex.getRang() + "]");
              break;
            }
          }
        }
      }
    }
  }
  
	public boolean generationPDFPossible() {
    return false;
  }
    
  public ObjetPDF genererPDF(ObjetPDF oPDF) throws DocumentException, FileNotFoundException, IOException  {
    return oPDF;
  }

  public ObjetPDF genererPDF(ObjetPDF oPDF, Eleve eleve) throws DocumentException, FileNotFoundException, IOException  {
    return oPDF;
  }
  
  public String getNomApplication() {
    return "";
  }

  public String getVersionApplication() {
    return "";
  }
  
  protected String formateDate(Calendar date) {
    String jj = (date.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + date.get(Calendar.DAY_OF_MONTH);
    String mm = (date.get(Calendar.MONTH) < 9 ? "0" : "") + (date.get(Calendar.MONTH)+1);
    String aaaa = "" + date.get(Calendar.YEAR);      
    return jj + "/" + mm;
  }
  
  public void chargeLesEvaluations() { // charge la totalité des évaluations de l'application
  }
  
  public void videLesEvaluations() { // vide la totalité des évaluations de l'application
  }
  
  protected DefaultListModel Vector2Model(Vector v) {
    if (v == null) 
      return null; 
    DefaultListModel lm = new DefaultListModel();
    for(int i = 0; i < v.size(); i++) 
      lm.addElement(v.elementAt(i));
    return lm;      
  }
  
  static protected Vector fusionne2Vectors(Vector v1, Vector v2) {
    if (v1 == null && v2 == null)
      return null;
    Vector v = new Vector();
    if (v1 != null)
      for(int i = 0; i < v1.size(); i++) 
        v.addElement(v1.elementAt(i));
    if (v2 != null)
      for(int i = 0; i < v2.size(); i++)  
        if (!v.contains(v2.elementAt(i)))
          v.addElement(v2.elementAt(i));
    return v;      
  }
  
  public Mire genereMire(Evaluation evaluation, Eleve eleve) {
    return null;
  }
  
  public int getNbEvaluations() {
    return getLesItemsEvaluationsSelectionnes(false).size();
  } 
  
  public void setClasseSelectionnee(Classe classe) {
    _laClasseSelectionnee = classe;
  }

  public void setElevesSelectionnes(Vector<Eleve> lesEleves) {
    _lesElevesSelectionnes = lesEleves;
  }
  
  public void valueChanged(ListSelectionEvent evt) {
  }  
  
  public void itemStateChanged(ItemEvent evt) {
    if (evt.getSource() == _cbNiveaux) {
      if (_listeNiveaux.getModel() != null && 
          _listeNiveaux.getModel().getSize() > 0) {
        selectionneTousLesItems(_listeNiveaux, _cbNiveaux.isSelected());
      }
    }
    if (evt.getSource() == _cbEvaluations) {
      if (_listeEvaluations.getModel() != null && 
          _listeEvaluations.getModel().getSize() > 0) {
        selectionneTousLesItems(_listeEvaluations, _cbEvaluations.isSelected());
      }
    }
  }
  
  protected void selectionneTousLesItems(JListJButton listeItems, boolean selected) {
    if (listeItems.getModel() != null && 
        listeItems.getModel().getSize() > 0) {
      ListModel liste = listeItems.getModel();
      for(int t = 0; t < liste.getSize(); t++) {
        ItemObjet item = (ItemObjet)liste.getElementAt(t);
        item.setSelected(selected);
      }
      ((TbiAdmin)_app).majPlugin(this);    
      listeItems.repaint();
    }
  }  
  
  public void mouseClicked(MouseEvent evt) {
    majPlugin();
  }

  public void mouseEntered(MouseEvent evt) {
  }

  public void	mouseExited(MouseEvent evt) {
  }
  
  public void mousePressed(MouseEvent evt) {
  }

  public void	mouseReleased(MouseEvent evt) {
  }
  
  public void majPlugin() {
    ((TbiAdmin)_app).majPlugin(this);
  } 
  
  protected int getDureeReponse(boolean max) {
    int ret = -1;
    Vector<ItemEvaluation> lesItemsEvaluations = getLesItemsEvaluationsSelectionnes(true);    
    for(int i =  0; i < lesItemsEvaluations.size(); i++) {
      ItemEvaluation iEval = lesItemsEvaluations.elementAt(i);
      Evaluation eval = iEval.getEvaluation();
      int retEval = eval.getDureeReponse(max); 
      if (ret == -1 || 
          (max && ret < retEval) ||
          (!max && ret > retEval)) {
        ret = retEval;
      }
    }
    return ret;  
  }
  
  public void setItemApplication(ItemApplication item) {
    _itemApplication = item;
  }
  
  public void setSelected(boolean selected) {
  }
  
  public void chargeSkin(String skin) {
    try {
      File fichier = new File(_application.getRepertoire(), skin);
      if (fichier.exists() && fichier.isFile()) 
        _lesSkins.put(skin, new Skin(_app, fichier.getAbsolutePath(), skin));
    } catch(Exception e) {
      _app.message(e.toString(), _app.MESSAGE_ERREUR);
    }
  } 
  
  public Skin getSkin(String skin) {
    return _lesSkins.get(skin);    
  }
  
  protected String getIdMois(int n) {
    switch(n) {
      case 1 : return "Janvier";
      case 2 : return "Fevrier";
      case 3 : return "Mars";
      case 4 : return "Avril";
      case 5 : return "Mai";
      case 6 : return "Juin";
      case 7 : return "Juillet";
      case 8 : return "Aout";
      case 9 : return "Septembre";
      case 10 : return "Octobre";
      case 11 : return "Novembre";
      case 12 : return "Decembre";
    }
    return "";
  }

  protected String getIdJour(int n) {
    if (n == Calendar.MONDAY) return "Lundi";
    if (n == Calendar.TUESDAY) return "Mardi";
    if (n == Calendar.WEDNESDAY) return "Mercredi";
    if (n == Calendar.THURSDAY) return "Jeudi";
    if (n == Calendar.FRIDAY) return "Vendredi";
    if (n == Calendar.SATURDAY) return "Samedi";
    if (n == Calendar.SUNDAY) return "Dimanche";
    return "";
  }
  
} 