/*
Copyright Caroline et Serge COUDÉ, (02/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiGeneral;

import net.sergecoude.util.JPanelTranslucide;
import java.awt.event.*;
import javax.swing.*;
import java.awt.*;

public class ItemClasseGen extends JPanelTranslucide {

  private final static long serialVersionUID = 1L;
  
  protected TbiApp _app;
  protected Classe _classe = null;
  protected boolean _estSelectionnee = false;
  protected ActionListener _actionListener = null;
  protected JList _jListe = null;
  protected int _nbEleves = 0;
  protected String _nom = "";
  
  public ItemClasseGen(float transparence, Classe classe) {
    super(transparence);
    _classe = classe;
    _app = _classe.getApplication();
    addComponentListener(this);
  }

  public ItemClasseGen(Classe classe) {
    this(1f, classe);
  }
  
  public Classe getClasse() {
    return _classe;
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    g.setColor(_estSelectionnee ? _jListe.getSelectionBackground() : _jListe.getBackground());
    g.fillRect(0, 0, getWidth(), getHeight());
  }
  
  public void setEnabled(boolean enabled) {
  }
  
  public void setJList(JList l) {
    _jListe = l;
  }
  
  public void setNbEleves(int n) {
    _nbEleves = n;
    update();
  }

  public void setNom(String nom) {
    _nom = nom;
    update();
  }
  
  public void update() {
  }
  
  public void selectionne(boolean select) {
    _estSelectionnee = select;
    repaint();
  }
  
  public void setHauteur(int h) {
  }
  
}