/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.util.Map.*;

public class PanelConfig extends Panneau implements ActionListener {

  private final static long serialVersionUID = 1L;

  protected JRadioButton _brConfDefaut, _brConfPerso;
  protected Box _pConf;
  protected JRadioButton _brTailleSouris1, _brTailleSouris2, _brTailleSouris3;
  protected JRadioButton _brTbiOui, _brTbiNon;
  protected JRadioButton _brUtilClasseOui, _brUtilClasseNon;
  protected JTextField _tfTbiLargeur, _tfTbiHauteur, _tfTbiX, _tfTbiY;
  protected JPanel _bUtilClasse, _bNbExercices, _bSkins;
  protected JComboBox _cbNbExercices;
  protected JComboBox _cbSkins;
  protected bouton _bEnregistrer;
  protected JPanel _pConfTbi; 
	
  public PanelConfig(TbiApp app) {
    super(app);
		// bandeau par defaut, puis en haut si affichage des paramètres
    _brConfDefaut = new JRadioButton("par défaut");
		_brConfDefaut.setFont(_police);
		_brConfDefaut.setOpaque(false);
    _brConfDefaut.setSelected(true);
    _brConfDefaut.addActionListener(this);
    _brConfPerso = new JRadioButton("personnalisée");
		_brConfPerso.setFont(_police);
		_brConfPerso.setOpaque(false);
		_brConfPerso.addActionListener(this);
    ButtonGroup groupConf = new ButtonGroup();
    groupConf.add(_brConfDefaut);
    groupConf.add(_brConfPerso);
	  try {
      _bEnregistrer = new bouton(_app.getRessourceByConf("boutonenregistrer"));
  		_bEnregistrer.addActionListener(this);
  	} catch(Exception e) {
  	 _app.log(e);
    }

    ResizeLabelFont lConfiguration = new ResizeLabelFont("Configuration ?", JLabel.CENTER);
    lConfiguration.setFont(_police);
    lConfiguration.setOpaque(true);
    lConfiguration.setBackground(Color.lightGray);
    lConfiguration.setAlignmentX(CENTER_ALIGNMENT);
    Box pConfiguration = Box.createHorizontalBox();
    pConfiguration.add(Box.createHorizontalGlue());
    pConfiguration.add(lConfiguration);
    pConfiguration.add(_brConfDefaut);
    pConfiguration.add(_brConfPerso);
    pConfiguration.add(Box.createHorizontalGlue());
    pConfiguration.add(_bEnregistrer);
    pConfiguration.setAlignmentX(CENTER_ALIGNMENT);

    // panneau par défaut des paramètres communs à toutes les applications
    // taille de la souris
		_brTailleSouris1 = new JRadioButton("1 (32x32)");
		_brTailleSouris1.setFont(_police);
		_brTailleSouris1.setOpaque(false);
		if (_app.getTailleCurseur() == 1)
      _brTailleSouris1.setSelected(true);
		_brTailleSouris2 = new JRadioButton("2 (64x64)");
		_brTailleSouris2.setFont(_police);
		_brTailleSouris2.setOpaque(false);
		if (_app.getTailleCurseur() == 2)
      _brTailleSouris2.setSelected(true);
		_brTailleSouris3 = new JRadioButton("3 (128x128)");
		_brTailleSouris3.setFont(_police);
		_brTailleSouris3.setOpaque(false);
		if (_app.getTailleCurseur() == 3)
      _brTailleSouris3.setSelected(true);
    ButtonGroup groupTailleSouris = new ButtonGroup();
    groupTailleSouris.add(_brTailleSouris1);
    groupTailleSouris.add(_brTailleSouris2);
    groupTailleSouris.add(_brTailleSouris3);
    JPanel pTailleSouris = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pTailleSouris.setOpaque(false);
    pTailleSouris.add(_brTailleSouris1);
    pTailleSouris.add(_brTailleSouris2);
    pTailleSouris.add(_brTailleSouris3);
    pTailleSouris.setAlignmentX(CENTER_ALIGNMENT);    
    ResizeLabelFont lTailleSouris = new ResizeLabelFont("Taille de la souris", JLabel.CENTER);
    lTailleSouris.setFont(_police);
    lTailleSouris.setOpaque(true);
    lTailleSouris.setBackground(Color.lightGray);
    lTailleSouris.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel bTailleSouris = new JPanel(new FlowLayout(FlowLayout.CENTER));
    bTailleSouris.setOpaque(false);
    bTailleSouris.add(lTailleSouris);
    bTailleSouris.add(pTailleSouris);
    // utilisation ou non du tbi
    _brTbiOui = new JRadioButton("Oui");
		_brTbiOui.setFont(_police);
		_brTbiOui.setOpaque(false);
		if (_app.getAvecTbi())
      _brTbiOui.setSelected(true);
    _brTbiOui.addActionListener(this);  
    _brTbiNon = new JRadioButton("Non");
		_brTbiNon.setFont(_police);
		_brTbiNon.setOpaque(false);
		if (!_app.getAvecTbi())
      _brTbiNon.setSelected(true);
    _brTbiNon.addActionListener(this);
    Font police = new Font("SansSerif", Font.BOLD, 20);
    _pConfTbi = new JPanel(new FlowLayout(FlowLayout.CENTER));
    _pConfTbi.setOpaque(false);
    _tfTbiLargeur = new JTextField(Integer.toString(_app.getLargeurTbi()));
    _tfTbiLargeur.setPreferredSize(new Dimension(60,30));
    _tfTbiLargeur.setFont(police);
    _tfTbiHauteur = new JTextField(Integer.toString(_app.getHauteurTbi()));
    _tfTbiHauteur.setPreferredSize(new Dimension(60,30));
    _tfTbiHauteur.setFont(police);
    _tfTbiX = new JTextField(Integer.toString(_app.getXTbi()));
    _tfTbiX.setPreferredSize(new Dimension(60,30));
    _tfTbiX.setFont(police);
    _tfTbiY = new JTextField(Integer.toString(_app.getYTbi()));
    _tfTbiY.setPreferredSize(new Dimension(60,30));
    _tfTbiY.setFont(police);
    ResizeLabelFont lX = new ResizeLabelFont("X:");
    lX.setFont(police); 
    ResizeLabelFont lY = new ResizeLabelFont("Y:");
    lY.setFont(police); 
    ResizeLabelFont lLargeur = new ResizeLabelFont("Largeur:");
    lLargeur.setFont(police); 
    ResizeLabelFont lHauteur = new ResizeLabelFont("Hauteur:");
    lHauteur.setFont(police);
    _pConfTbi.add(lX);
    _pConfTbi.add(_tfTbiX);
    _pConfTbi.add(lY);
    _pConfTbi.add(_tfTbiY);
    _pConfTbi.add(lLargeur);                  
    _pConfTbi.add(_tfTbiLargeur);
    _pConfTbi.add(lHauteur);
    _pConfTbi.add(_tfTbiHauteur);
    ButtonGroup groupTbi = new ButtonGroup();
    groupTbi.add(_brTbiOui);
    groupTbi.add(_brTbiNon);
    JPanel pAvecSansTbi = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pAvecSansTbi.setOpaque(false);
    pAvecSansTbi.add(_brTbiOui);
    pAvecSansTbi.add(_brTbiNon);
    pAvecSansTbi.add(_pConfTbi);
    pAvecSansTbi.setAlignmentX(CENTER_ALIGNMENT);    
    ResizeLabelFont lAvecSansTbi = new ResizeLabelFont("Avec TBI ?", JLabel.CENTER);
    lAvecSansTbi.setFont(_police);
    lAvecSansTbi.setOpaque(true);
    lAvecSansTbi.setBackground(Color.lightGray);
    lAvecSansTbi.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel bAvecSansTbi = new JPanel(new FlowLayout(FlowLayout.CENTER));
    bAvecSansTbi.setOpaque(false);
    bAvecSansTbi.add(lAvecSansTbi);
    bAvecSansTbi.add(pAvecSansTbi);
    // utilisation des classes ou non
    _brUtilClasseOui = new JRadioButton("Oui");
		_brUtilClasseOui.setFont(_police);
		_brUtilClasseOui.setOpaque(false);
		_brUtilClasseOui.addActionListener(this);
		if (_app.getUtilisationDesClasses())
      _brUtilClasseOui.setSelected(true);
    _brUtilClasseNon = new JRadioButton("Non");
		_brUtilClasseNon.setFont(_police);
		_brUtilClasseNon.setOpaque(false);
		_brUtilClasseNon.addActionListener(this);
		if (!_app.getUtilisationDesClasses())
      _brUtilClasseNon.setSelected(true);
    ButtonGroup groupUtilClasse = new ButtonGroup();
    groupUtilClasse.add(_brUtilClasseOui);
    groupUtilClasse.add(_brUtilClasseNon);
    JPanel pUtilClasse = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pUtilClasse.setOpaque(false);
    pUtilClasse.add(_brUtilClasseOui);
    pUtilClasse.add(_brUtilClasseNon);
    pUtilClasse.setAlignmentX(CENTER_ALIGNMENT);
    ResizeLabelFont lUtilClasse = new ResizeLabelFont("Utilisation des classes ?", JLabel.CENTER);
    lUtilClasse.setFont(_police);
    lUtilClasse.setOpaque(true);
    lUtilClasse.setBackground(Color.lightGray);
    lUtilClasse.setAlignmentX(Component.CENTER_ALIGNMENT);
    _bUtilClasse = new JPanel(new FlowLayout(FlowLayout.CENTER));
    _bUtilClasse.setOpaque(false);
    _bUtilClasse.add(lUtilClasse);
    _bUtilClasse.add(pUtilClasse);
    // nombre d'exercices
    String[] nbExs = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10" };
    _cbNbExercices = new JComboBox(nbExs);
    _cbNbExercices.setSelectedItem(Integer.toString(_app.getNbExercices()));
    _cbNbExercices.setPreferredSize(new Dimension(80,30));
    _cbNbExercices.setFont(_police);
    _bNbExercices = new JPanel(new FlowLayout(FlowLayout.CENTER));
    _bNbExercices.setOpaque(false);
    ResizeLabelFont lNbExercices = new ResizeLabelFont("Nombre d'exercices :", JLabel.CENTER);
    lNbExercices.setFont(_police);
    lNbExercices.setOpaque(true);
    lNbExercices.setBackground(Color.lightGray);
    _bNbExercices.add(lNbExercices);
    _bNbExercices.add(_cbNbExercices);
    _bNbExercices.setAlignmentX(CENTER_ALIGNMENT);
    _cbSkins = new JComboBox();
    _cbSkins.setPreferredSize(new Dimension(300,30));
    _cbSkins.setFont(_police);
    _bSkins = new JPanel(new FlowLayout(FlowLayout.CENTER));
    _bSkins.setOpaque(false);
    ResizeLabelFont lSkins = new ResizeLabelFont("Habillage :", JLabel.CENTER);
    lSkins.setFont(_police);
    lSkins.setOpaque(true);
    lSkins.setBackground(Color.lightGray);
    _bSkins.add(lSkins);
    _bSkins.add(_cbSkins);
    _bSkins.setAlignmentX(CENTER_ALIGNMENT);
    _bSkins.setVisible(false);
    // bandeau de navigation
    try {
      _bPrecedent = new bouton(app.getRessourceByConf("boutonprecedent"));
      _bPrecedent.addActionListener(this);
    } catch (Exception e) {
      _app.log(e);
    }
    try {
      _bSuivant = new bouton(app.getRessourceByConf("boutonsuivant"));
      _bSuivant.addActionListener(this);
    } catch (Exception e) {
      _app.log(e);
    }
    JPanel pNavigation = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pNavigation.setOpaque(false);
    pNavigation.add(_bPrecedent);
    pNavigation.add(_bSuivant);
    pNavigation.setAlignmentX(CENTER_ALIGNMENT);
    
    // agencement général commun aux application
    _pConf = Box.createVerticalBox();
    _pConf.add(bTailleSouris);
    _pConf.add(Box.createRigidArea(new Dimension(0,10)));
    _pConf.add(bAvecSansTbi);
    _pConf.add(Box.createRigidArea(new Dimension(0,10)));
    _pConf.add(_bUtilClasse);
    _pConf.add(Box.createRigidArea(new Dimension(0,10)));
    JPanel pCombos = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pCombos.setOpaque(false);
    pCombos.add(_bNbExercices);
    pCombos.add(_bSkins);
    _pConf.add(pCombos);
    _pConf.add(Box.createRigidArea(new Dimension(0,10)));    
    _pConf.setAlignmentX(CENTER_ALIGNMENT);
    // au demarrage
    _pConf.setVisible(false);
    _bEnregistrer.setVisible(false);
    
    // agencement général
    Box bMain = Box.createVerticalBox();
    bMain.setOpaque(false);
    setLayout(new BorderLayout());
    bMain.add(pConfiguration);
    bMain.add(Box.createVerticalGlue());
    bMain.add(_pConf);
    bMain.add(pNavigation);
    add(bMain);
    bMain.setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
 
    updateConfTbi();
  }
  
  protected void preEnregistrer() { // met à jour les config
		if (_brUtilClasseOui.isSelected())
		  _app.setUtilisationDesClasses(true);
		else 
		  _app.setUtilisationDesClasses(false);
		if (_brTailleSouris1.isSelected())
		  _app.setTailleCurseur(1);
		else if (_brTailleSouris2.isSelected())
		  _app.setTailleCurseur(2);
 		else 
 		  _app.setTailleCurseur(3);
		if (_brTbiOui.isSelected())
		  _app.setAvecTbi(true);
		else 
		  _app.setAvecTbi(false);
		_app.setLargeurTbi(Integer.parseInt(_tfTbiLargeur.getText()));
		_app.setHauteurTbi(Integer.parseInt(_tfTbiHauteur.getText()));
		_app.setXTbi(Integer.parseInt(_tfTbiX.getText()));
		_app.setYTbi(Integer.parseInt(_tfTbiY.getText()));
		_app.setNbExercices(Integer.parseInt((String)_cbNbExercices.getSelectedItem()));
		if (_app.getLesSkins().size() > 0)
      _app.setSkin(((Skin)_cbSkins.getSelectedItem()).getNom());		  
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bSuivant) {
		   preEnregistrer();
       if (_app.getUtilisationDesClasses())
         _app.setPanneau("SelectClasseGen");
       else  
  		   _app.setPanneau(_app.getPanneauApresSelectClasse("premier"));
  		 _app.majAffichage(); // on bascule pour la suite des panneaux sur un affichage réduit si utilisation du Tbi
		}
		if (source == _bPrecedent) {
		  _app.setPanneau("SelectEcran");
		}
		if (source == _brConfDefaut) {
		  updateConfiguration();
		}
		if (source == _brConfPerso) {
      updateConfiguration();		  
		}
		if (source == _brTbiOui) {
		  _app.setAvecTbi(true);
		  updateConfTbi();
		}
		if (source == _brTbiNon) {
		  _app.setAvecTbi(false);
      updateConfTbi();		  
		}
		if (source == _bEnregistrer) {
		  preEnregistrer();
      /*************************************
       * 0 : TbiGeneralApp.conf    
       * 1 : TbiGeneral.conf
       * 2 : Tbi.......App.conf     
       * 3 : Tbi........conf
       *************************************/
      _app.sauveConfiguration();   
		}
  }
  
  private void updateConfTbi() {
		if (_app.getAvecTbi()) 
      _pConfTbi.setVisible(true);
    else
      _pConfTbi.setVisible(false);
  }
  
  private void updateConfiguration() {
		if (_brConfDefaut.isSelected()) {
		  init(true);
      _pConf.setVisible(false);
      _bEnregistrer.setVisible(false);
    } else {
      _pConf.setVisible(true);
      _bEnregistrer.setVisible(true);
    }
  }
  
  public void init() {
    super.init();
    init(false);
  }
  
  public void init(boolean defaut) {
    int tailleSouris = _app.getTailleCurseur();
    if (defaut)
      tailleSouris = Integer.parseInt(_app.getConfiguration(_app._V_TailleSouris)); 
  	if (tailleSouris == 1)
		  _brTailleSouris1.setSelected(true);
	  else if (tailleSouris == 2)
		  _brTailleSouris2.setSelected(true);
		else 
		  _brTailleSouris3.setSelected(true);
    
    if (!_app.isEcranPrincipal()) { // obligation de TBI
      _brTbiOui.setSelected(true);
      _brTbiNon.setEnabled(false);
      _app.setAvecTbi(true);
      updateConfTbi();        
    } else {
      boolean avecTbi = _app.getAvecTbi();
      if (defaut)
        avecTbi = _app.getConfiguration(_app._V_UtilisationTBI).toLowerCase().equals("oui") ? true : false; 
      if (avecTbi) 
        _brTbiOui.setSelected(true);
      else 
        _brTbiNon.setSelected(true);
      updateConfTbi();
    }
    
    String largeur = Integer.toString(_app.getLargeurTbi());
    largeur = _app.getConfiguration(_app._V_LargeurTBI);      
    _tfTbiLargeur.setText(largeur);
    String hauteur = Integer.toString(_app.getHauteurTbi());
    hauteur = _app.getConfiguration(_app._V_HauteurTBI);      
    _tfTbiHauteur.setText(hauteur);
    String coordx = Integer.toString(_app.getXTbi());
    if (defaut)
      coordx = _app.getConfiguration(_app._V_CoordXTBI);      
    _tfTbiX.setText(coordx);
    String coordy = Integer.toString(_app.getYTbi());
    if (defaut)
      coordy = _app.getConfiguration(_app._V_CoordYTBI);      
    _tfTbiY.setText(coordy);

    boolean utilclasse = _app.getUtilisationDesClasses();
    if (defaut)
      utilclasse = _app.getConfiguration(_app._V_UtilisationDesClasses).toLowerCase().equals("oui") ? true : false; 
    if (utilclasse)
      _brUtilClasseOui.setSelected(true);
    else 
      _brUtilClasseNon.setSelected(true);
      
    String nbexercices = Integer.toString(_app.getNbExercices());
    if (defaut)
      nbexercices = _app.getConfiguration(_app._V_NbExercices);      
    _cbNbExercices.setSelectedItem(nbexercices);
    HashMap<String,Skin> lesSkins = _app.getLesSkins();
    if (lesSkins.size() > 0) {
      for(Entry<String, Skin> entree : lesSkins.entrySet()) {
        _cbSkins.addItem(entree.getValue());
        if (_app.getConfiguration(_app._V_NomDuSkin).equals("")) {
          if (_app.getNomDuSkin().equals(entree.getKey()))
            _cbSkins.setSelectedItem(entree.getValue());
        } else if (_app.getConfiguration(_app._V_NomDuSkin).equals(entree.getKey()))
          _cbSkins.setSelectedItem(entree.getValue());
      }
      _bSkins.setVisible(true);
    } else
      _bSkins.setVisible(false); 
    if (lesSkins.size() < 2) 
      _cbSkins.setEnabled(false);
    else
      _cbSkins.setEnabled(true);  
  }
 
}
