/*
Copyright Caroline et Serge COUDÉ, (01/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.event.*;
import java.util.*;

public class PanelSelectEleveGen extends Panneau {

  private final static long serialVersionUID = 1L;

  private JPanel _pEleves;
  private ResizeLabelFont _lEleves;
	
  public PanelSelectEleveGen(TbiApp app) {
    super(app);
		
    try {
      _bPrecedent = new bouton(_app.getRessourceByConf("boutonprecedent"));
      _bPrecedent.addActionListener(this);
    } catch (Exception e) {
      _app.log(e);
    }

    JPanel pMain = new JPanel();
    pMain.setLayout(new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();
    pMain.setOpaque(false);
    setLayout(new BorderLayout());
    _lEleves = new ResizeLabelFont("Choisissez l'élève...", JLabel.CENTER);
    _lEleves.setFont(_police);
    _lEleves.setAlignmentX(CENTER_ALIGNMENT);
    c.fill = GridBagConstraints.NONE;
    c.gridwidth = 1;
    c.gridheight = 1;
    c.gridx = 0;
    c.gridy = 0;
    pMain.add(_lEleves, c);
    c.gridheight = 2;
    _pEleves = new JPanel();
    _pEleves.setOpaque(false);
    _pEleves.setLayout(new GridBagLayout());
    c.gridx = 0;
    c.gridy = 1;
    pMain.add(_pEleves, c);
    c.gridheight = 1;
    c.gridx = 0;
    c.gridy = 3;
    JPanel pPrecedent = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pPrecedent.setOpaque(false);
    pPrecedent.add(_bPrecedent);
    pMain.add(pPrecedent, c);    
    add(pMain);
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bPrecedent) {
		 // on désélectionne les élèves
		 deselectionneLesEleves();
		 _app.setPanneau(_app.getPanneauApresSelectClasse("dernier")); // dernier panneau avant celui-ci
		}
  }
  
  public void agenceLesComposants() {
    _pEleves.removeAll();
    _pEleves.revalidate();
    ArrayList<Eleve> lesElevesDeLaClasse = _app.getClasse().getLesEleves();
    ArrayList<Eleve> lesEleves = new ArrayList<Eleve>();
    for(int i = 0; i < lesElevesDeLaClasse.size(); i++) {
      if (lesElevesDeLaClasse.get(i).estPresent())
        lesEleves.add(lesElevesDeLaClasse.get(i));
    }
    int largeur = _app.getLargeurTbi()-(2*20);
    int hauteur = _app.getHauteurTbi()/2;
    _pEleves.setPreferredSize(new Dimension(largeur, hauteur));    
    int marge = 15; // marge entre items
    // calcul de la répartition optimale des items
    int nbColonnes = 0;
    int nbLignes = 0;
    int sTot = largeur*hauteur;
    int sTmp = 0;
    int lItem = 0; // largeur d'un item après calcul
    int hItem = 0; // hauteur d'un item après calcul
    int nbEleves = lesEleves.size();
    for(int c = nbEleves; c > 0; c--) {
      for(int r = nbEleves; r > 0; r--) {
        if (c*r >= nbEleves) {
          int l = largeur / c; // largeur d'un item
          int h = (int)(l / ItemEleve.ratio); // deduction de la hauteur
          if (h*r <= hauteur) {
            int s = l*h*nbEleves;
            if (s > sTmp && s <= sTot) { 
              sTmp = s;
              nbColonnes = c;
              nbLignes = r;
              lItem = l-(2*marge);
              hItem = h-(2*marge);
            }
          }
        }
      }
    }
    if (lItem == 0) {
      nbColonnes = 0;
      nbLignes = 0;
      sTmp = 0;
      lItem = 0; // largeur d'un item après calcul
      hItem = 0; // hauteur d'un item après calcul
      for(int r = nbEleves; r > 0; r--) {
        for(int c = nbEleves; c > 0; c--) {
          if (c*r >= nbEleves) {
            int h = hauteur / r; // hauteur d'un item
            int l = (int)(h * ItemEleve.ratio); // deduction de la largeur
            if (l*c <= largeur) {
              int s = l*h*nbEleves;
              if (s > sTmp && s <= sTot) { 
                sTmp = s;
                nbColonnes = c;
                nbLignes = r;
                lItem = l-(2*marge);
                hItem = h-(2*marge);
              }
            }
          }
        }
      }
    }
    GridBagConstraints cnstr = new GridBagConstraints();
    cnstr.fill = GridBagConstraints.NONE;
    cnstr.ipadx = marge;
    cnstr.ipady = marge;      
    cnstr.gridwidth = 1;
    cnstr.gridheight = 1;
    cnstr.weightx = 1d;
    cnstr.weighty = 1d;
    int l = 0, c = 0;
    for(int e = 0; e < nbEleves; e++) {
      ItemEleve item = (ItemEleve)(lesEleves.get(e).getItemEleve());
      item.setPreferredSize(new Dimension(lItem,hItem));
      cnstr.gridx = c;
      cnstr.gridy = l;
      _pEleves.add(item, cnstr);
      c++;                                                             
      if (c == nbColonnes) {
        c = 0;
        l++;
      }
    }
    _pEleves.revalidate();
    _pEleves.repaint();

    // maj de la police
    float surf = 1024 * 768;
    float surfTbi = _app.getLargeurTbi() * _app.getHauteurTbi();
    float ratio = (float)Math.sqrt(surfTbi / surf);
    Dimension dLabel = new Dimension(3*_app.getLargeurTbi()/4,(int)(_hauteurPolice*2*ratio));
    _lEleves.setMinimumSize(dLabel);
    _lEleves.setMaximumSize(dLabel);
    _bPrecedent.setRatio(ratio);
    revalidate();
  }
  
  
  private void deselectionneLesEleves() {
    ArrayList<Eleve> lesEleves = _app.getClasse().getLesEleves();
    for(int e = 0; e < lesEleves.size(); e++) {
      Eleve eleve = lesEleves.get(e);
      eleve.getItemEleve().selectionne(false);
    }
  }
  
}
