/*
Copyright Caroline et Serge COUDÉ, (01/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiGeneral;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ResizeLabelFont extends JLabel {

  private final static long serialVersionUID = 1L;
    
    public static final int MIN_FONT_SIZE=3;
    public static final int MAX_FONT_SIZE=70;
    private float _hauteurPoliceInitiale = 0f;
    private Graphics _g;
 
    public ResizeLabelFont(String text) {
        super(text);
        init();
    }

    public ResizeLabelFont(String text, int align) {
        super(text, align);
        init();
    }

 
    protected void init() {
        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                adaptLabelFont();
            }
        });
    }
 
    protected void adaptLabelFont() {
      Rectangle r = getBounds();
      r.x = 0; r.y = 0;
      int fontSize = MIN_FONT_SIZE;
      Font f = getFont();
      if (f == null)
        return;
      Rectangle r1 = new Rectangle();
      Rectangle r2 = new Rectangle();
      while (fontSize < MAX_FONT_SIZE && fontSize < _hauteurPoliceInitiale) {
          r1.setSize(getTextSize(f.deriveFont((float)fontSize)));
          r2.setSize(getTextSize(f.deriveFont((float)fontSize+1)));
          if (r.contains(r1) && ! r.contains(r2)) {
              break;
          }
          fontSize++;
      }
      super.setFont(f.deriveFont((float)fontSize));
      repaint();
    }
 
    private Dimension getTextSize(Font f) {
        Dimension size = new Dimension();
        FontMetrics fm = null;
        if (_g != null) {
          _g.setFont(f);
          fm = _g.getFontMetrics(f);
        } else 
          fm = getFontMetrics(f);
        if (fm != null) {
          size.width = fm.stringWidth(getText());
          size.height = fm.getHeight();
        }
        return size;
    }
 
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        _g = g;
    }
    
    public void setFont(Font f) {
      _hauteurPoliceInitiale = (float)(f.getSize());
      super.setFont(f);
    }
    
    public void setText(String t) {
      super.setText(t);
      adaptLabelFont();
    }
}