/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import java.net.*;
import java.io.*;
import java.util.*;
import java.util.jar.*;

public class Skin  {

  private final static long serialVersionUID = 1L;
  
  protected TbiApp _app = null;
  protected File _fichierJar = null;
  protected HashMap<String,URL> _magasin = null;
  protected HashMap<String,String> _traduction = null; 
  protected String _nom = "";
    
  public Skin(TbiApp app, String chemin, String nom) throws Exception {
    _app = app;
    _fichierJar = new File(chemin);
    _nom = nom;
    if (!_fichierJar.exists()) 
      throw new Exception("le skin '" + _fichierJar.getAbsolutePath() + "' n'existe pas...");
    chargeLesDefinitions();  
  }
  
  private void chargeLesDefinitions() throws Exception {
    _magasin = new HashMap<String,URL>();
    _traduction = new HashMap<String,String>();
    URL u = _fichierJar.toURI().toURL();
    JarFile jar = new JarFile(_fichierJar.getAbsolutePath());
    Enumeration enumeration = jar.entries();
    while(enumeration.hasMoreElements()){
		  String entree = enumeration.nextElement().toString();
      if(entree.toLowerCase().endsWith("manifest.mf")) {
        String strManifest = "jar:" + u + "!/" + entree; 
        URL urlManifest = new URL(strManifest);
        InputStream isManifest = urlManifest.openStream();      				  
        BufferedReader readerManifest = new BufferedReader(new InputStreamReader(isManifest, "UTF-8"));
        String ligne = "";
        while ((ligne = readerManifest.readLine()) != null) {
          ligne = ligne.trim();
          if (!ligne.equals("") &&
              !ligne.toLowerCase().startsWith("manifest-version:") &&
              !ligne.toLowerCase().startsWith("created-by:")
             ) {
            StringTokenizer st = new StringTokenizer(ligne, ":");
				    String cle = st.nextToken().trim();
				    String valeur = st.nextToken().trim();
				    if (cle.startsWith("trad"))
				      _traduction.put(cle, valeur);
				    else 
				      _magasin.put(cle, new URL("jar:" + u + "!/" + valeur));
          }
        }
        readerManifest.close(); 
      }
    }
  }
  
  public URL getRessource(String ress) {
    return _magasin.get(ress);
  }

  public String getTraduction(String ress) {
    return _traduction.get("trad"+ress);
  }
  
  public String getNom() {
    return _nom;
  }
  
  public String toString() {
    return _nom.substring(4);
  }
	
}