/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/

package net.sergecoude.TbiGeneral;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
import javax.imageio.*;
import java.net.*;
import java.io.*;
import java.awt.color.*;
import javax.swing.border.*;

public class bouton extends JComponent {

	ActionListener actionListener = null;
	String titre;
	protected boolean enfonce = false;
	protected BufferedImage image_fond;
	protected BufferedImage image_fond_enfoncee; 
	protected int hauteur = 100, largeur = 60;
	protected int _hauteurIni = 0, _largeurIni = 0;
	protected boolean chargementTermine = false;
	protected boolean taille_forcee = false;
	private final static long serialVersionUID = 1L;
	protected boolean _pret = false;
	protected boolean _enabled = true;
	
	public bouton() {
		this("");
	}
	
	public bouton(String titre) {
		this.titre = titre;
		image_fond = null;
		image_fond_enfoncee = null;
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
		_pret = true;
	}
	
	public bouton(URL img) throws Exception {
	  if (img != null) {
		  this.titre = img.toString();
		  setImage(img);
		}
	  enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}
	
	public bouton (int w, int h) {
		this("",w,h);
		largeur = w;
		hauteur = h;
		_largeurIni = w;
		_hauteurIni = h;
  	setSize(largeur,hauteur);
		taille_forcee = true;
		_pret = true;		
	}
	
	public bouton(String titre, int w, int h) {
		this.titre = titre;
		image_fond = null;
		image_fond_enfoncee = null;
		largeur = w;
		hauteur = h;
		_largeurIni = w;
		_hauteurIni = h;
		setSize(largeur,hauteur);
		taille_forcee = true;
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
		_pret = true;		
	}
	
	public bouton(URL img, int w, int h) throws Exception {
	  if (img != null) {
		  this.titre = img.toString();
		  setImage(img, w, h);
		}
	  enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}
	
  public bouton(BufferedImage img) throws Exception {
		this.titre = "";
		setImage(img);
    enableEvents(AWTEvent.MOUSE_EVENT_MASK);			
	}	

	public void setLabel(String titre) {
		this.titre = titre;
		invalidate();
		repaint();
	}
	
	public void paint(Graphics g) {
		Dimension d = getSize();
		Graphics2D g2 = (Graphics2D)g;
		g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
    g2.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    g2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
    g2.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE);
    g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
    if (!_enabled && image_fond != null) {
      AlphaComposite composite = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.2f);
      g2.setComposite(composite); 
      g.drawImage(image_fond,0,0,d.width,d.height,this);
      g2.dispose();
      return;
    }
		if (image_fond != null && chargementTermine && !enfonce)
    			g.drawImage(image_fond,0,0,d.width,d.height,this);
		if (image_fond_enfoncee != null && chargementTermine && enfonce)
    			g.drawImage(image_fond_enfoncee,0,0,d.width,d.height,this);
		else if (image_fond == null) {
		  g.setColor(getBackground());
		  g.fillRect(0,0,largeur,hauteur);
			g.setColor(getForeground());
			g.drawRect(0,0,largeur,hauteur);
			Font f = getFont();
			if (f != null) {
				FontMetrics fm = getFontMetrics(f);
				g.drawString(titre,largeur/2-fm.stringWidth(titre)/2,hauteur/2+fm.getMaxDescent());
			}
			Border border = getBorder();
			if (border != null) {
			  border.paintBorder(this,g,0,0,largeur,hauteur); 
      }
		}
	}

	public Dimension getPreferredSize() {
		return new Dimension(largeur,hauteur);
	}

	public Dimension getMinimumSize() {
		return new Dimension(largeur,hauteur);
	}

	public Dimension getMaximumSize() {
		return new Dimension(largeur,hauteur);
	}

	public int getLargeur() {
		return largeur;
	}

	public int getHauteur() {
		return hauteur;
	}
	
	public void setDimension(int w, int h) {
    largeur = w;
    hauteur = h;
 		setSize(largeur,hauteur);
		taille_forcee = true;
  }

 	public void setRatio(float r) {
    largeur = (int)(r*(float)_largeurIni);
    hauteur = (int)(r*(float)_hauteurIni);
 		setSize(largeur,hauteur);
		taille_forcee = true;
  }

	public void addActionListener(ActionListener listener) {
	  if (actionListener == null) {
		  actionListener = AWTEventMulticaster.add(actionListener,listener);
		  enableEvents(AWTEvent.MOUSE_EVENT_MASK);
		}
	}
	
	public void removeActionListener(ActionListener listener) {
		actionListener = AWTEventMulticaster.remove(actionListener,listener);
		actionListener = null;
	}

	public boolean contains(int x, int y) {
		return (x >= 0 && y >= 0 && x < getSize().width && y < getSize().height);
	}
	
	public void processMouseEvent(MouseEvent e) {
		if (!_enabled)
		  return;  
		switch(e.getID()) {
  		case MouseEvent.MOUSE_PRESSED:
	   		enfonce = true;
		  	repaint();
  			break;
	   	case MouseEvent.MOUSE_RELEASED:
		  	if (enfonce == true) {
			   	enfonce = false;
				  repaint();
        }
        break;
		case MouseEvent.MOUSE_ENTERED:
        break;
		case MouseEvent.MOUSE_EXITED:
			if (enfonce == true) {
				enfonce = false;
				repaint();
			}
			break;
  	case MouseEvent.MOUSE_CLICKED:
			if (actionListener != null) {
				actionListener.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,titre));
			}
			break;
		}
		super.processMouseEvent(e);
	}

	private void attenteChargement() throws Exception {
	  int cpt = 0; 
		while((cpt < 30 && image_fond == null) || (image_fond != null && (image_fond.getWidth(null) < 0 || image_fond.getHeight(null) < 0))) 
			try {
				Thread.sleep(100);
				cpt++;
			} catch(Exception e) {
			  throw e;
      }
    if (image_fond == null) {
      image_fond = null;
      image_fond_enfoncee = null;
      return;
    }
		chargementTermine = true;
		ColorConvertOp gris = new ColorConvertOp(ColorSpace.getInstance(ColorSpace.CS_GRAY), null);
		image_fond_enfoncee = gris.createCompatibleDestImage(image_fond,image_fond.getColorModel());
		gris.filter(image_fond, image_fond_enfoncee);
		if (!taille_forcee) {
			hauteur = image_fond.getHeight(this);
			largeur = image_fond.getWidth(this);
  		_largeurIni = largeur;
	   	_hauteurIni = hauteur;
		}
		_pret = true;		
	}

	public String toString() {
		return "[bouton x:" + getX() + ", y:" + getY() + ", w:" + getLargeur() + ", h:" + getHauteur() + " image:" + titre + "]";
	}

	public void setLocation(int x, int y) {
		setBounds(x,y,getLargeur(),getHauteur());
	}
	
	public boolean pret() {
	 return _pret;
  }
  
  public void setImage(URL img) throws Exception {
  	try {
			image_fond = ImageIO.read(img);
			attenteChargement();
		} catch (Exception e) {
			image_fond = null;
			image_fond_enfoncee = null;
			enableEvents(AWTEvent.MOUSE_EVENT_MASK);
			throw e;
		}
  }

  public void setImage(URL img, int w, int h) throws Exception {
		try {
			image_fond = ImageIO.read(img);
			attenteChargement();
  		largeur = w;
	   	hauteur = h;
  		_largeurIni = w;
	   	_hauteurIni = h;
		  setSize(largeur,hauteur);
		  taille_forcee = true;
		} catch(IOException ioe) {
			image_fond = null;
			image_fond_enfoncee = null;
  		largeur = w;
	   	hauteur = h;
  		_largeurIni = w;
	   	_hauteurIni = h;
		  setSize(largeur,hauteur);
		  taille_forcee = true;
		  enableEvents(AWTEvent.MOUSE_EVENT_MASK);
      throw ioe; 
		}
  }
  
  public void setImage(BufferedImage img) throws Exception {
		image_fond = img;
    attenteChargement();		
  }
  
  public void setEnabled(boolean enabled) {
    _enabled = enabled;
    repaint();
  }
      
}
